
define(['mundo/exec', 'mundo/event',

        'core/startWorkController',
        'core/thanksController',
        'core/storeLocationController',
        'core/storePhotoController',
        'core/scanCodeController',
        'core/productListController',
        'core/countInputController',
        'core/submitHistoryController',

        'core/services',
        'core/controllers',
        'core/directives'],

    function (Exec, Event) {

        console.info("Cigarette App Load!");
        var app = angular.module('app', [
            'ui.router', 'ionic', 'controllers', 'directives', 'services', 'ngIOS9UIWebViewPatch'
        ]);

        app.config(['$stateProvider', '$urlRouterProvider', '$ionicConfigProvider', function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

            $ionicConfigProvider.views.maxCache(0);

            $urlRouterProvider.otherwise("/loading");

            $stateProvider
                /* 加载页面 */
                .state('loading', {
                    url: "/loading",
                    templateUrl: "views/loading.html"
                })
                .state('startWork', {
                    url: "/startWork",
                    templateUrl: "views/startWork.html",
                    controller: "StartWorkCtrl"
                })

                .state('productList', {
                    url: "/productList",
                    templateUrl: "views/productList.html",
                    controller: "ProductListCtrl"
                })

                .state('countInput', {
                    url: "/countInput",
                    templateUrl: "views/countInput.html",
                    controller: "CountInputCtrl"
                })

                .state('submitHistory', {
                    url: "/submitHistory",
                    templateUrl: "views/submitHistory.html",
                    controller: "SubmitHistoryCtrl"
                })

                /* 定位页面 */
                .state('storeLocation', {
                    url: "/storeLocation",
                    templateUrl: "views/storeLocation.html",
                    controller: "StoreLocationCtrl"
                })

                /* 扫描页面 */
                .state('scanCode', {
                    url: "/scanCode",
                    templateUrl: "views/scanCode.html",
                    controller: "ScanCodeCtrl"
                })

                /*  */
                .state('inputCode', {
                    url: "/inputCode/:type",
                    templateUrl: "views/scanCode.html",
                    controller: "ScanCodeCtrl"
                })

                /* 照片 */
                .state('storePhoto', {
                    url: "/storePhoto",
                    templateUrl: "views/storePhoto.html",
                    controller: "StorePhotoCtrl"
                })

                /* 差事完成，鸣谢 */
                .state('thanks', {
                    url: "/thanks/:fromSeq",
                    templateUrl: "views/thanks.html",
                    controller: "ThanksCtrl"
                });

        }]);

        app.run(['$q', '$http', '$rootScope', '$window', '$timeout', '$state', '$dialog', '$taskLoader', '$contextUtils',
            function($q, $http, $rootScope, $window, $timeout, $state, $dialog, $taskLoader, $contextUtils) {
                $window.answers = {};
                $window.globalPhotoSeq = 10000;
                $window.answers.tempAnswer = [];
                $window.stateHistory = [];
                /* 退出，保存答案*/
                $window.document.addEventListener('back', function(event) {
                    event.preventDefault();
                    Exec(function(args){
                        if (args.buttonIndex < 3) {
                            if (args.buttonIndex == 1) {
                                $contextUtils.save($window.answers);
                            }
                            $contextUtils.back();
                        }
                    }, function(args) {

                    }, "Dialogs", "confirm", [{ message: "是否保存答案？", title: "提示", buttonLabels: ["保存", "不保存", "取消"] }]);
                });

                /* 提交答案 */
                $window.document.addEventListener('submit', function(event) {
                    Exec(function(args) {}, function(args) {}, "Context", "submit", [{ answer: $window.answers }]);
                });
                //$taskLoader.load('data/demo.json')
                //    .then(function(taskDetail) {
                //        $timeout(function() {
                            // 加载Task数据成功
                            //$contextUtils.load()
                            //    .then(function(answers) {
                            //        if (answers) {
                            //            $window.answers = answers;
                            //        }
                            //        $state.go("storeLocation");
                            //    }, function(error) {
                            //        $dialog.alert(error);
                            //    });
                    //        $state.go("startWork");
                    //    }, 500);
                    //}, function(error) {
                    //    var errorMessage = encodeURIComponent(error);
                    //    console.log(errorMessage);
                    //});

                $contextUtils.load()
                    .then(function(answers) {
                        if (answers) {
                            $window.answers = answers;
                        }
                        var params = {
                            "url": "2.2/cigarette/getAnswersByCus",
                            "data": {
                                "page": 1,
                                "count": 20
                            }
                        };

                        Exec(function(args) {
                            console.log(args);
                            $window.totalNum = args.totalNum;
                            $window.answerList = args.answerList;
                            if ( $window.totalNum == 0) {
                                $state.go("storeLocation");
                            } else {
                                $state.go("startWork");
                            }
                        }, function(args) {
                            alert(JSON.stringify(args));
                        }, "API", "get", [params]);
                    }, function(error) {
                        $dialog.alert(error);
                    });
        }]);

        return app;
});
