define(['core/controllers'],
    function(controllers) {
        console.info('CountInputCtrl Load!');

        controllers.controller('CountInputCtrl', ['$scope', '$rootScope', '$window', '$q', '$state', '$code', '$dialog', '$stateParams', '$contextUtils',
            function($scope, $rootScope, $window, $q, $state, $code, $dialog, $stateParams, $contextUtils) {
                $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" + "统计产品信息";
                $scope.description = "请认真填写一下信息";

                $scope.seq = $window.answers.tempAnswer.length;
                $scope.answer = $window.answers.tempAnswer[$scope.seq] || {"inventory": null, "purchase": null, "price": null, "pricePack": null};

                $scope.scanCode = function() {
                    $code
                        .scanCode()
                        .then(function(code) {
                            $scope.code = code;
                            $scope.answer = code;
                        }, function(error) {
                            console.log(error);
                        });
                };


                $scope.prev = function(){
                    if ($window.answers.tempAnswer.length == 1) {
                        $state.go("scanCode");
                    } else {
                        $state.go("storePhoto");
                    }
                };

                $scope.complete = function() {
                    if ($scope.answer.inventory != 0 && !$scope.answer.inventory) {
                        $dialog.alert("请输入库存");
                        return false;
                    } else  if($scope.answer.purchase != 0 && !$scope.answer.purchase) {
                        $dialog.alert("请输入进货数");
                        return false;
                    } else  if(!$scope.answer.price) {
                        $dialog.alert("请输入价格");
                        return false;
                    } else  if(!$scope.answer.pricePack) {
                        $dialog.alert("请输入价格");
                        return false;
                    } else if (!_.isNumber($scope.answer.inventory) || !_.isNumber($scope.answer.purchase) || !_.isNumber($scope.answer.price) || !_.isNumber($scope.answer.pricePack)
                        || _.isNaN($scope.answer.inventory) || _.isNaN($scope.answer.purchase)  || _.isNaN($scope.answer.price) ||  _.isNaN($scope.answer.pricePack)) {
                        $dialog.alert("请输入数字");
                        return false;
                    } else if(hasDot($scope.answer.inventory) || $scope.answer.inventory < 0) {
                        $dialog.alert("库存格式不正确");
                        return false;
                    } else if(hasDot($scope.answer.purchase || $scope.answer.purchase < 0)) {
                        $dialog.alert("进货数格式不正确");
                        return false;
                    } else if ($scope.answer.price >= $scope.answer.pricePack) {
                        $dialog.alert("请确认香烟价格(条>包)");
                        return false;
                    }

                    $window.answers.tempAnswer[$scope.seq] = $scope.answer;

                    var branchSeq = $window.answers[1].length;
                    $window.answers[1][branchSeq] = $window.answers.tempAnswer;
                    $window.answers.tempAnswer = [];

                    $contextUtils.save($window.answers);

                    $state.go("productList", null, {location: 'replace'});
                };

                function hasDot(num) {
                    if (!isNaN(num)) {
                        return ((num + '').indexOf('.') != -1) ? true : false;
                    }
                }

            }]);

    });
