define(['core/controllers', 'mundo/exec'],
    function(controllers, Exec) {
        console.info('ProductListCtrl Load!');

        controllers.controller('ProductListCtrl', ['$scope', '$rootScope', '$window', '$q', '$state', '$code', '$dialog', '$stateParams', '$gps', '$ionicLoading',
            function($scope, $rootScope, $window, $q, $state, $code, $dialog, $stateParams, $gps, $ionicLoading) {
                $scope.seq = 1;
                $scope.answer = $window.answers[$scope.seq] || [];
                $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" + "添加产品" ;
                $scope.products = [];
                _.each($scope.answer, function(item){
                    var product = item[0].product;
                    if (product){
                        var name = product.name||product.customerName;
                        $scope.products.push(name);
                    } else  {
                        $scope.products.push("未知");
                    }
                });

                $scope.next = function() {

                };

                $scope.add = function() {
                    $state.go("scanCode");
                    $window.answers[$scope.seq] = $scope.answer;
                };

                $scope.delete = function(count) {
                    var self = this;
                    var deleteItem = $scope.answer[count];
                    var products = _.filter($scope.products, function(item, index) {
                        return count != index;
                    });
                    $scope.products = products;

                    var answer = _.filter($scope.answer, function(item, index) {
                        return count != index;
                    });
                    $scope.answer = answer;
                    $window.answers[$scope.seq] = $scope.answer;

                    if (deleteItem.length == 3) {
                        var photoSeq =  deleteItem[1];
                        var photos = _.filter($window.answers.photos, function(value) {
                            return photoSeq != value;
                        });

                        $window.answers.photos = photos;
                        delete $window.answers[photoSeq];
                    }
                };

                $scope.complete = function() {
                    if ($scope.answer.length == 0) {
                        $dialog.alert('没有数据');
                        return false;
                    }
                    $state.go("thanks");
                };

                $scope.prev = function() {
                    $state.go("storeLocation");
                };

                $scope.submit = function() {
                    if (_.isEmpty($window.answers)) {
                        $dialog.alert("还没有数据");
                        return false;
                    }
                    $ionicLoading.show({
                        template: '<ion-spinner icon="ios-small"></ion-spinner>'
                    });
                    $gps.getLocation2()
                        .then(function(location) {
                            $window.answers[2] = location;
                            $ionicLoading.hide();
                            Exec(function(args) {}, function(args) {}, "Context", "submit", [{ answer: $window.answers }]);
                        }, function(error) {
                            $ionicLoading.hide();
                            $dialog.alert(error);
                        });
                };
            }]);

    });
