
define(['core/controllers', 'mundo/exec'],
    function (controllers, Exec) {
        console.info('ScanCodeCtrl Load!');

        controllers.controller('ScanCodeCtrl', ['$scope', '$rootScope', '$window', '$q', '$state', '$code', '$dialog', '$stateParams', '$http',  '$ionicLoading', '$timeout', '$contextUtils', '$ionicLoading',
            function ($scope, $rootScope, $window, $q, $state, $code, $dialog, $stateParams, $http, $ionicLoading, $timeout, $contextUtils, $ionicLoading) {
                //$scope.description = "";
                $scope.type = $stateParams.type||0;

                if($scope.type == 0) {
                    $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" + "扫描香烟条形码";
                } else {
                    $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" + "输入香烟条形码";
                }

                $scope.noProduct = false;
                $scope.showSelectProductPanel = false;
                $scope.seq = 0;
                if (!$window.answers.tempAnswer) {
                    $window.answers.tempAnswer = [];
                }
                $scope.answer = $window.answers.tempAnswer[$scope.seq] || {};
                $scope.manualInput = $scope.answer.manualInput||false;
                $scope.product = $scope.answer.product || {name: "", customerName:""};
                $scope.code = $scope.answer.code;

                console.log($scope.product);

                $scope.handleQueryProductResult = function (data) {
                    $scope.showSelectProductPanel = true;
                    $scope.products = [];
                    if (!data.barCode || data.barCode.length == 0) {
                        $scope.noProduct = true;
                    } else {
                        $scope.noProduct = false;
                        var products = [];
                        var checkedProductNames = [];
                        var branchAnswer = $window.answers[1];
                        _.each(branchAnswer, function(item){
                            var name = item[0].product.name;
                            checkedProductNames.push(name);
                        });
                        data.barCode =  _.difference(data.barCode, checkedProductNames);
                        _.each(data.barCode, function (value) {
                            var size = value.length;
                            if (size > 32) {
                                var part1 = value.substring(0, 32);
                                var part2 = value.substring(32, size);
                                value = part1 + "<br/>" + part2;
                            }
                            var product = {"name": value, "customerName": ""};
                            products.push(product);
                        });

                        $scope.products = products;
                    }
                    $ionicLoading.hide();
                }

                $scope.queryProduct = function () {
                    if (!$scope.code) {
                        return;
                    }
                    $ionicLoading.show({
                        template: '<ion-spinner icon="ios-small"></ion-spinner>'
                    });
                    var defer = $q.defer();
                    var params = {
                        "url": "2.2/tasks/getNameByCode",
                        "data": {
                            "barCode": $scope.code
                        }
                    };

                    Exec(function(args) {
                        $ionicLoading.hide();
                        defer.resolve(args);
                    }, function(args) {
                        $ionicLoading.hide();
                        defer.reject(JSON.stringify(args));
                    }, "API", "get", [params]);

                    return defer.promise;
                };

                $scope.confirmInputCode = function(){
                    if(!$scope.code) {
                        $dialog.alert("请先填写条形码");
                        return false;
                    }
                    console.log($scope.code);
                    console.log(_.isNumber($scope.code));
                    console.log(isNumeric($scope.code));
                    if (!isNumeric($scope.code)) {
                        $dialog.alert("请输入数字");
                        return false;
                    }

                    $scope.answer.code = $scope.code;
                    $scope.answer.manualInput = true;
                    $window.answers.tempAnswer[$scope.seq] = $scope.answer;
                    $state.go("scanCode");
                };

                $scope.barcodeInputBlur = function(){
                    if (!_.isNumber($scope.code)
                        || _.isNaN($scope.code)) {
                        $dialog.alert("请输入数字");
                        return false;
                    }
                    $scope.queryProduct().then(function (data) {
                        $scope.handleQueryProductResult(data);
                    }, function (error) {
                        $ionicLoading.hide();
                        console.log(error);
                    });
                };

                $scope.getAnswersByName = function () {
                    $ionicLoading.show({
                        template: '<ion-spinner icon="ios-small"></ion-spinner>'
                    });
                    var defer = $q.defer();
                    var name = $scope.product.name||$scope.product.customerName;
                    var params = {
                        "url": "2.2/cigarette/getAnswersByName",
                        "data": {
                            "name": name
                        }
                    };

                    Exec(function(args) {
                        defer.resolve(args);
                        $ionicLoading.hide();
                    }, function(args) {
                        defer.reject(JSON.stringify(args));
                        $ionicLoading.hide();
                    }, "API", "get", [params]);

                    return defer.promise;
                };

                if ($scope.code && $scope.type == 0) {
                    $scope.queryProduct().then(function (data) {
                        $scope.handleQueryProductResult(data);
                    }, function (error) {
                        $ionicLoading.hide();
                        console.log(error);
                    });
                }

                $scope.goToInputCode = function(){
                    $state.go("inputCode", { type: 1 });
                };

                $scope.scanCode = function () {
                    $ionicLoading.show({
                        template: '<ion-spinner icon="ios-small"></ion-spinner>'
                    });

                    $timeout(function(){
                        $ionicLoading.hide();
                    }, 3000);

                    $code
                        .scanCode()
                        .then(function(code) {
                            $scope.code = code;
                            $scope.queryProduct().then(function (data) {
                                $scope.handleQueryProductResult(data);
                            }, function (error) {
                                $ionicLoading.hide();
                                console.log(error);
                            });
                        }, function(error) {
                            $ionicLoading.hide();
                            console.log(error);
                        });
                };

                $scope.toggleState = function(){
                    if ($scope.manualInput) {
                        $scope.manualInput = false;
                        $scope.code = null;
                    } else {
                        $scope.manualInput = true;
                    }
                    $scope.showSelectProductPanel = false;
                };

                $scope.codeInputChange = function (code){
                   $scope.code = code;
                };

                $scope.customerNameInputChange = function(name){
                    if (name) {
                        $scope.product.name = "";
                        $scope.manualInput = true;
                    }
                }

                $scope.select = function (item) {
                    $scope.product = _.clone(item);
                    $scope.product.name = $scope.product.name.replace("<br/>","");
                    $scope.manualInput = false;
                    if(!$scope.code) {
                        $dialog.alert("请先扫描条形码");
                        return false;
                    } else if(!($scope.product.name || $scope.product.customerName)){
                        $dialog.alert("输入产品名称");
                        return false;
                    }

                    $scope.goToNextPage();
                };

                $scope.next = function () {
                    if(!$scope.code) {
                        $dialog.alert("请先扫描条形码");
                        return false;
                    } else if(!($scope.product.name || $scope.product.customerName)){
                        $dialog.alert("输入产品名称");
                        return false;
                    }

                    $scope.goToNextPage();
                };

                $scope.goToNextPage = function(){
                    var checkedProductNames = [];
                    var branchAnswer = $window.answers[1];
                    _.each(branchAnswer, function(item){
                        var name = item[0].product.name||item[0].product.customerName;
                        checkedProductNames.push(name);
                    });

                    var name = $scope.product.name||$scope.product.customerName;

                    if (_.contains(checkedProductNames, name)) {
                        $dialog.alert("该产品已添加");
                        return false;
                    }

                    $scope.code = parseInt($scope.code);
                    $scope.getAnswersByName().then(function (data) {
                        console.log(data);
                        var status = data.status;
                        if (status == 1) {
                            $dialog.alert("该产品已添加!");
                        } else {
                            $scope.answer.manualInput = $scope.manualInput;
                            $scope.answer.product = $scope.product;
                            $scope.answer.code = $scope.code;
                            $window.answers.tempAnswer[$scope.seq] = $scope.answer;
                            $contextUtils.save($window.answers);
                            if ($scope.manualInput) {
                                $state.go("storePhoto");
                            } else {
                                $state.go("countInput");
                            }
                        }
                    }, function (error) {
                        console.log(error);
                        $dialog.alert("校验失败!");
                    });
                };

                $scope.prev = function () {
                    if ($scope.type == 0) {
                        $state.go("productList");
                    } else {
                        $state.go("scanCode");
                    }

                };

                function isNumeric(n) {
                    return !isNaN(parseFloat(n)) && isFinite(n);
                }
            }]);
    });
