define(['core/controllers'],
    function(controllers) {

    console.info('StoreLocationCtrl Load!');

    controllers.controller('StoreLocationCtrl', ['$scope', '$window', '$dialog', '$gps', '$ionicLoading', '$timeout', '$state', '$stateParams', '$timeout', '$contextUtils',
        function($scope, $window, $dialog, $gps, $ionicLoading, $timeout, $state, $stateParams, $timeout, $contextUtils) {
            $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" + "点击定位获取当前店铺的GPS";
            $scope.seq = 0;
            $scope.answer = $window.answers[$scope.seq] || {};
            $scope.totalNum = window.totalNum;
            $scope.location = $scope.answer.location;
            $scope.revisedAddress = $scope.answer.revisedAddress;

            $timeout(function(){
                $ionicLoading.hide();
            }, 3000);

            if ($scope.location) {
                $scope.locationInfo = "经度：" + $scope.location.longitude + ", 纬度：" + $scope.location.latitude;
                    //+ ($scope.location.address ? (", 位置：" + $scope.location.address) : "");
            }

            $scope.getLocation = function() {

                $ionicLoading.show({
                    template: '<ion-spinner icon="ios-small"></ion-spinner>'
                });

                $gps.getLocation2()
                    .then(function(location) {
                        $scope.location = location;
                        if ($scope.location) {
                            $scope.locationInfo = "经度：" + $scope.location.longitude + ", 纬度：" + $scope.location.latitude;
                                //+ ($scope.location.address ? (", 位置：" + $scope.location.address) : "");
                        }

                        $scope.showTextArea = true;

                        $ionicLoading.show({
                            template: '<i class="icon ion-information-circled"></i>&nbsp;定位成功'
                        });

                        $timeout(function() {
                            $ionicLoading.hide();
                            // 关闭自动跳转
                            // $state.go('storePhoto');
                        }, 600);

                    }, function(error) {
                        $ionicLoading.hide();
                        $dialog.alert(error);
                    });
            };

            $scope.next = function() {
                if (!$scope.location) {
                    $dialog.alert('请先定位');
                    return false;
                }

                $scope.answer.location = $scope.location;
                $scope.answer.revisedAddress = $scope.revisedAddress;
                $window.answers[$scope.seq] = $scope.answer;
                $contextUtils.save($window.answers);
                $state.go("productList");
            };

            $scope.prev = function() {
                $state.go("startWork");
            };

            $scope.textChanged = function(revisedAddress) {
                $scope.revisedAddress = revisedAddress;
            };

    }]);

});