define(['core/controllers'],
    function(controllers) {
        console.info('StorePhotoCtrl Load!');

        controllers.controller('StorePhotoCtrl', ['$scope', '$rootScope', '$window', '$q', '$state', '$camera', '$dialog', '$stateParams', '$contextUtils', '$ionicModal',
            function($scope, $rootScope, $window, $q, $state, $camera, $dialog, $stateParams, $contextUtils, $ionicModal) {
                $scope.validateStr = "拍摄店香烟照片和香烟条形码";
                $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" + $scope.validateStr;
                $scope.description = "照片须清晰显示香烟照片和香烟条形码";
                console.log("totalNum:" + $scope.totalNum);
                $scope.picInfo = {
                    "title": "示例图",
                    "pics": [
                        {
                            "image": "img/pic-1.jpg",
                            "label": "示例图-1"
                        },
                        {
                            "image": "img/pic-2.jpg",
                            "label": "示例图-2"
                        },
                        {
                            "image": "img/pic-3.jpg",
                            "label": "示例图-3"
                        }
                    ]
                };
                $scope.seq =  1;
                if ($window.answers.tempAnswer[$scope.seq]) {
                    var photoSeq = $window.answers.tempAnswer[$scope.seq];
                    $scope.photos = $window.answers[photoSeq];
                } else {
                    $scope.photos = [];
                }

                $scope.chooseImage = function() {
                    var maxCount = 3 - $scope.photos.length;
                    if(maxCount == 0) {
                        $dialog.alert("最多选择3张照片");
                        return false;
                    }
                    $camera
                        .getPicture({ maxCount: maxCount, writeMetadata: false })
                        .then(function(images) {
                            _.each(images, function(image) {
                                image.checked = false;
                                image.thumbnail = image.imagePath
                                    .replace('.png','.thumbnail.png')
                                    .replace('.jpg','.thumbnail.jpg');
                            });
                            $scope.photos = $scope.photos.concat(images);
                            //$scope.$digest();
                        }, function(error) {
                            console.log(error);
                            //$dialog.alert(JSON.stringify(error));
                        });
                };

                $scope.deleteImage = function() {
                    var photos = _.filter($scope.photos, function(photo) {
                        return !photo.checked;
                    });

                    if (photos.length == $scope.photos.length) {
                        $dialog.alert("请先点选要删除的照片");
                    }

                    $scope.photos = photos;
                };

                $scope.clickImage = function(photoIndex) {
                    $scope.photos[photoIndex].checked = !$scope.photos[photoIndex].checked;
                };

                $scope.next = function() {
                    if($scope.photos.length < 3 ) {
                        $dialog.alert("照片不能小于3张");
                        return false;
                    }

                    var photoSeq = $window.globalPhotoSeq++;
                    $window.answers.tempAnswer[$scope.seq] = photoSeq;

                    if (!$window.answers.photos){
                        $window.answers.photos = [];
                    }
                    $window.answers.photos.push(photoSeq);
                    $window.answers.photos = _.uniq($window.answers.photos);
                    $window.answers[photoSeq] = $scope.photos;

                    $contextUtils.save($window.answers);
                    $state.go("countInput");
                };

                $scope.prev = function() {
                    $state.go("scanCode");
                };

                $ionicModal.fromTemplateUrl('views/pic.html', {
                    scope: $scope,
                    animate: 'slide-in-up'
                }).then(function(modal){
                    $scope.modal = modal;
                });

                $scope.openPicModal = function() {
                    $scope.modal.show();
                };
                $scope.closePicModal = function() {
                    $scope.modal.hide();
                };
                //Cleanup the modal when we're done with it!
                $scope.$on('$destroy', function() {
                    $scope.modal.remove();
                });
            }]);
    });
