define(['core/controllers', 'mundo/exec'],
    function(controllers, Exec) {
        console.info('SubmitHistoryCtrl Load!');

        controllers.controller('SubmitHistoryCtrl', ['$scope', '$rootScope', '$window', '$q', '$state', '$code', '$dialog', '$stateParams', '$http', '$ionicLoading',
            function($scope, $rootScope, $window, $q, $state, $code, $dialog, $stateParams, $http, $ionicLoading) {
                $scope.seq = 1;
                $scope.answer = $window.answers[$scope.seq] || [];
                $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" + "提交历史" ;
                $scope.products = [];
                $scope.page = 1;
                $scope.count = 20;

                $scope.getMyTasks = function(){
                    $ionicLoading.show({
                        template: '<ion-spinner icon="ios-small"></ion-spinner>'
                    });
                    var params = {
                        "url": "2.2/cigarette/getAnswersByCus",
                        "data": {
                            "page": $scope.page,
                            "count": $scope.count
                        }
                    };

                    Exec(function(args) {
                        $ionicLoading.hide();
                        console.log(args);
                        var totalNum = args.totalNum;
                        $scope.totalNum = totalNum;
                        var answerList = args.answerList;
                        if (answerList.length > 0) {
                            _.each(answerList, function(item){
                                $scope.products.push(item);
                            });
                            $scope.page++;
                        }
                    }, function(args) {
                        $ionicLoading.hide();
                        alert(JSON.stringify(args));
                    }, "API", "get", [params]);
                };

                $scope.next = function() {

                };

                $scope.loadMore = function(){
                    $scope.getMyTasks();
                };

                $scope.prev = function() {
                    $state.go("startWork");
                };

                $scope.delete = function(count){
                    $dialog.confirm("是否确定删除?").then(function(data){
                       if (data) {
                           $ionicLoading.show({
                               template: '<ion-spinner icon="ios-small"></ion-spinner>'
                           });
                           var item = $scope.products[count];
                           var products = _.filter($scope.products, function(item, index) {
                               return count != index;
                           });
                           var params = {
                               "url": "2.2/cigarette/deleteAnswersByName",
                               "data": {
                                   "name": item.name
                               }
                           };

                           Exec(function(args) {
                               $ionicLoading.hide();
                               var status = args.status;
                               if (status == 1) {
                                   $dialog.alert("删除成功!");
                                   $scope.products = products;
                                   $window.totalNum--;
                               } else {
                                   $dialog.alert("删除失败!");
                               }
                           }, function(args) {
                               $ionicLoading.hide();
                               $dialog.alert(JSON.stringify(args));
                           }, "API", "get", [params]);
                       }
                    }, function(data){
                        console.log(data);
                    });
                };

                $scope.getMyTasks();
            }]);

    });
