define(['underscore', 'mundo/exec'], function(_, Exec) {

    console.info("Native Method [Choose Image] Load!");

    function Camera($q) {
        var _q = $q;

        function getPicture (params) {
            var deferred = _q.defer();

            var defaultParams = {
                sourceType: 2, // 来源类型，0：拍摄、 1：从相册或文件夹选择、2：全部
                mediaType: 0, // 多媒体类型，0：照片、 1：视频、2：全部
                encodingType: params.encodingType === undefined ? 0 : params.encodingType, // 图片保存格式，0：JPEG、 1：PNG
                quality: params.quality === undefined ? 80 : params.quality, // 照片质量：0~100，当encodingType为JPEG时有效
                targetSize: params.targetSize === undefined ? { width: 720, height: 1280 } : params.targetSize,// 目标尺寸，为空则不处理
                thumbnailSize: {
                    width: 300,
                    height: 300
                }, // 缩略图尺寸，为空则不返回
                maxCount: params.maxCount == undefined ? 1 : params.maxCount, // 最多选择的数量，-1为不限制，默认为1
                onOrder: params.onOrder === undefined ? false : params.onOrder, // 是否按序选择，默认为否
                // saveToPhotoAlbum: params.saveToPhotoAlbum === undefined ? false : params.saveToPhotoAlbum, // 是否保存到相册，默认为否
                saveToPhotoAlbum: true,
                correctOrientation: true, // 是否纠正图片方向，默认为否
                allowEdit: false, // 是否允许编辑，默认为否
                writeMetadata: params.writeMetadata, // 是否写入GPS定位坐标和时间，默认为否，当encodingType为JPEG时有效
                savePath: window.assignmentId ? window.assignmentId.toString() : ""
            };

            Exec(function(args) {
                    console.info("[WCS] Camera.takePicture success!");
                    var images = args.medias;
                    deferred.resolve(images);
                },
                function(args) {
                    deferred.reject(args);
                }, "Camera", "takePicture", [defaultParams]);

            return deferred.promise;
        }

        return {
            getPicture: getPicture
        }
    }

    return Camera;
});