define(['mundo/exec', 'mundo/event'], function(Exec, Event) {

    console.info('ContextUtils Load!');

    function ContextUtils(deps) {

        var _q = deps.$q;

        function load() {
            var defer = _q.defer();
            Exec(function(args) {
                defer.resolve(args.answer);
            }, function(args) {
                defer.reject("加载答案失败");
            }, "Context", "load", [{}]);
            return defer.promise;
        }

        function back() {
            Exec(function(args) {}, function(args) {}, "App", "back", [{}]);
        }

        function save(answers) {
            Exec(function(args) {}, function(args) {}, "Context", "save", [{ answer: answers }]);
        }

        function submit(answers) {
            Exec(function(args) {}, function(args) {}, "Context", "submit", [{ answer: answers }]);
        }

        return {
            load: load,
            back: back,
            save: save
        }
    }

    return ContextUtils;
});
