define(['mundo/exec', 'mundo/event',
        'core/startWorkController',
        'core/issueController',
        'core/issueDescController',
        'core/addressLocationController',
        'core/storeNearbyPhotoController',
        'core/storeLocationController',
        'core/storeRenameController',
        'core/storePhotoController',

        'core/generalStaticController',
        'core/gskuStaticController',
        'core/countController',
        'core/countHistController',

        'core/photoAndCheckBoxController',
        'core/photoAndNumberInputController',
        'core/checkShelfController',

        'core/brandListDirective',
        'core/radioDirective',
        'core/suggestionController',
        'core/thanksController',
        'core/photoController',
        'core/services'],

    function (Exec, Event) {

        console.info("FMOT App Load!");

        function _rm(o, k) {
            // todo: remove $$hashKey
        }

        var fmot = angular.module('fmot', [
            'ui.router', 'ionic', 'controllers', 'directives', 'services', 'ngIOS9UIWebViewPatch'
        ]);

        fmot.config(['$stateProvider', '$urlRouterProvider', '$ionicConfigProvider', function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

            $ionicConfigProvider.views.maxCache(0);

            $urlRouterProvider.otherwise("/loading");

            $stateProvider
                /* 加载页面 */
                .state('loading', {
                    url: "/loading",
                    templateUrl: "views/loading.html"
                })

                /* 开始工作 seq:100 */
                .state('startWork', {
                    url: "/startWork",
                    templateUrl: "views/startWork.html",
                    controller: "StartWorkCtrl"
                })
                /* 差事异常，选择差事异常类型  */
                .state('issue', {
                    url: "/issue",
                    templateUrl: "views/issue.html",
                    controller: "IssueCtrl"
                })
                /* 差事异常，详细原因描述 */
                .state('issueDesc', {
                    url: "/issueDesc",
                    templateUrl: "views/issueDesc.html",
                    controller: "IssueDescCtrl"
                })
                /* 差事异常，定位指定地址的GPS */
                .state('addressLocation', {
                    url: "/addressLocation",
                    templateUrl: "views/storeLocation.html",
                    controller: "AddressLocationCtrl"
                })
                /* 差事异常，指定地址附近拍照  */
                .state('storeNearbyPhoto', {
                    url: "/storeNearbyPhoto",
                    templateUrl: "views/photo.html",
                    controller: "StoreNearbyPhotoCtrl"
                })
                /* 拍照  */
                .state('photo', {
                    url: "/photo",
                    templateUrl: "views/photo.html",
                    controller: "PhotoCtrl"
                })
                /* 店铺定位页面 */
                .state('storeLocation', {
                    url: "/storeLocation",
                    templateUrl: "views/storeLocation.html",
                    controller: "StoreLocationCtrl"
                })
                /* 确认店铺是否更名 */
                .state('storeRename', {
                    url: "/storeRename",
                    templateUrl: "views/storeRename.html",
                    controller: "StoreRenameCtrl"
                })
                /* 拍摄店铺门头照片 */
                .state('storePhoto', {
                    url: "/storePhoto",
                    templateUrl: "views/storePhoto.html",
                    controller: "StorePhotoCtrl"
                })

                /*xxx*/
                .state('photoAndCheckBoxO', {
                    url: "/photoAndCheckBoxO/",
                    templateUrl: "views/photoAndCheckBox.html",
                    controller: "PhotoAndCheckBoxCtrl"
                })
                .state('photoAndCheckBoxT', {
                    url: "/photoAndCheckBoxT/",
                    templateUrl: "views/photoAndCheckBox.html",
                    controller: "PhotoAndCheckBoxCtrl"
                })

                /*xxx*/
                .state('photoAndNumberInputO', {
                    url: "/photoAndNumberInputO",
                    templateUrl: "views/photoAndNumberInput.html",
                    controller: "PhotoAndNumberInputCtrl"
                })
                .state('photoAndNumberInputT', {
                    url: "/photoAndNumberInputT",
                    templateUrl: "views/photoAndNumberInput.html",
                    controller: "PhotoAndNumberInputCtrl"
                })
                /* 堆头/包柱 - 统计列表页面(h/s fmot) */
                .state('hsStaticOsd', {
                    url: "/hsStaticOsd", // 首次载入加tips
                    templateUrl: "views/generalStatic.html",
                    controller: "GeneralStaticCtrl"
                })
                /* 货架 - 统计列表页面(h/s & mini fmot) */
                .state('staticShelf', {
                    url: "/staticShelf", // 首次载入加tips
                    templateUrl: "views/generalStatic.html",
                    controller: "GeneralStaticCtrl"
                })
                /* 端架 - 统计列表页面(h/s & mini fmot) */
                .state('staticGondola', {
                    url: "/staticGondola", // 首次载入加tips
                    templateUrl: "views/generalStatic.html",
                    controller: "GeneralStaticCtrl"
                })
                /* GSKU - 统计列表页面(mini fmot gsku) */
                .state('staticGsku', {
                    url: "/staticGsku", // 首次载入加tips
                    templateUrl: "views/gskuStatic.html",
                    controller: "GskuStaticCtrl"
                })

                /* 计数页面 */
                .state('count', {
                    url: "/count/:seq/:type",
                    templateUrl: "views/count.html",
                    controller: "CountCtrl"
                })
                /* 修改数量页面 */
                .state('countHist', {
                    url: "/countHist/:seq/:type",
                    templateUrl: "views/countHist.html",
                    controller: "CountHistCtrl"
                })
                /*统计货架(只拍照)*/
                .state('checkShelf', {
                    url: "/checkShelf/:seq",
                    templateUrl: "views/checkShelf.html",
                    controller: "CheckShelfCtrl"
                })

                /* 用户建议与反馈 */
                .state('suggestion', {
                    url: "/suggestion/:fromSeq",
                    templateUrl: "views/suggestion.html",
                    controller: "SuggestionCtrl"
                })
                /* 差事完成，鸣谢 */
                .state('thanks', {
                    url: "/thanks/:fromSeq",
                    templateUrl: "views/thanks.html",
                    controller: "ThanksCtrl"
                });

        }]);

        fmot.run(['$q', '$http', '$rootScope', '$window', '$timeout', '$state', '$dialog', '$taskLoader', '$contextUtils',
            function($q, $http, $rootScope, $window, $timeout, $state, $dialog, $taskLoader, $contextUtils) {
                $window.globalPhotoSeq = 10000;
                $window.currentSeq = 0;
                $window.version = 3;
                $window.debugger = false;
                $window.routerIndex = 0;

                $window.router = [];
                $window.issuerouter =  ["startWork", "issue", "issueDesc", "addressLocation", "storeNearbyPhoto", "thanks"];

                $window.stateHistory = [];
                $window.getPhotoSeq = function(currentSeq) {
                    $window.globalPhotoSeq++;
                    var photoSeq = $window.globalPhotoSeq + 100000 * currentSeq;
                    return photoSeq;
                };

                /* 退出，保存答案*/
                $window.document.addEventListener('back', function(event) {
                    event.preventDefault();
                    // $dialog.alert('back()');
                    // console.log("current state: " + angular.toJson($state.current));

                    var currentState = $state.current.name;
                    console.log(currentState);
                    // 二级页面处理
                    var secondLevelStateList = ['count', 'countHist'];
                    if (_.indexOf(secondLevelStateList, currentState) > -1) {
                        var _ls = $window.stateHistory[$window.stateHistory.length - 2];
                        //if (currentState == 'count' || currentState == 'countHist') {
                        //    $state.go(_ls.state.name);
                        //}
                        console.log(_ls.state.name);
                        $state.go(_ls.state.name);
                        return false;
                    }

                    Exec(function(args){
                        if (args.buttonIndex < 3) {
                            if (args.buttonIndex == 1) {
                                $contextUtils.save($window.answers);
                            }
                            $contextUtils.back();
                        }
                    }, function(args) {

                    }, "Dialogs", "confirm", [{ message: "是否保存答案？", title: "提示", buttonLabels: ["保存", "不保存", "取消"] }]);
                });

                /* 提交答案 */
                $window.document.addEventListener('submit', function(event) {

                     $dialog.alert('submit()');

                    if (_.isEmpty($window.answers)) {
                        $dialog.alert("还没有数据");
                        return false;
                    }

                    //TODO 答案格式检测
                    Exec(function(args) {}, function(args) {}, "Context", "submit", [{ answer: $window.answers }]);

                });
                //$window.dataSource = "png-cst-drug-v2-rka";
                //$window.dataSource = "png-hsfmot-v3-flagship";
                //$window.dataSource = "png-cstcfmot-v3-flagship";
                //$window.dataSource = "png-bsfmot-v3-flagship";
                //$window.dataSource = "png-smfmot-v3-flagship";
                //$window.dataSource = "png-hs-v2-rka";
                //$window.dataSource = "png-sm-v2-rka";
                //$window.dataSource = "png-bbs-v2-rka";

                //$window.dataSource = "png-hn-bsfmot-v3-flagship";
                //$window.dataSource = "png-hn-smfmot-v3-flagship";

                var mapping = {};
                mapping["png-hsfmot-flagship"] =   ["startWork", "storeLocation", "storeRename", "storePhoto", "hsStaticOsd", "staticShelf", "staticGondola", "suggestion", "thanks"];
                mapping["png-hsfmot-blackpin"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "hsStaticOsd", "staticShelf", "staticGondola",  "staticGsku", "suggestion", "thanks"];
                mapping["png-cstcfmot-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "staticShelf", "photoAndCheckBoxO", "photoAndCheckBoxT", "suggestion", "thanks"];
                mapping["png-cstcfmot-blackpin"] =   ["startWork", "storeLocation", "storeRename", "storePhoto", "staticShelf", "staticGsku", "suggestion", "thanks"];
                mapping["png-bsfmot-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "photoAndCheckBoxO", "photoAndCheckBoxT", "suggestion", "thanks"];
                mapping["png-bsfmot-blackpin"] = ["startWork", "storeLocation", "storeRename", "storePhoto", "photoAndCheckBoxO", "staticGsku" ,"photoAndNumberInputO", "suggestion", "thanks"];
                mapping["png-smfmot-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "staticShelf", "staticGondola", "staticGsku", "suggestion", "thanks"];
                mapping["png-smfmot-blackpin"] = ["startWork", "storeLocation", "storeRename", "storePhoto", "staticShelf", "staticGondola", "staticGsku", "suggestion", "thanks"];
                mapping["png-hs-rka"] =["startWork", "storeLocation", "storeRename", "storePhoto", "hsStaticOsd", "staticShelf", "staticGondola", "staticGsku", "photoAndNumberInputO", "photoAndNumberInputT", "suggestion", "thanks"];
                mapping["png-sm-rka"] = ["startWork", "storeLocation", "storeRename", "storePhoto", "hsStaticOsd", "staticShelf", "staticGondola", "staticGsku", "photoAndNumberInputO",  "suggestion", "thanks"];
                mapping["png-cst-drug-rka"] =   ["startWork", "storeLocation", "storeRename", "storePhoto", "hsStaticOsd", "staticShelf", "staticGondola", "staticGsku",  "suggestion", "thanks"];
                mapping["png-bbs-rka"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "hsStaticOsd", "photoAndCheckBoxO", "staticGondola", "staticGsku", "suggestion", "thanks"];

                mapping["png-hsfmot-v2-flagship"] =   ["startWork", "storeLocation", "storeRename", "storePhoto", "hsStaticOsd", "staticShelf", "staticGondola", "suggestion", "thanks"];
                mapping["png-cstcfmot-v2-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "staticShelf", "photoAndCheckBoxO", "photoAndCheckBoxT", "suggestion", "thanks"];
                mapping["png-bsfmot-v2-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "photoAndCheckBoxO", "photoAndCheckBoxT", "suggestion", "thanks"];
                mapping["png-smfmot-v2-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "staticShelf", "staticGondola", "staticGsku", "suggestion", "thanks"];

                mapping["png-cst-drug-v2-rka"] =   ["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "hsStaticOsd", "staticShelf", "staticGondola", "staticGsku",  "suggestion", "thanks"];


                mapping["png-hsfmot-v3-flagship"] =   ["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "hsStaticOsd", "staticShelf", "staticGondola", "suggestion", "thanks"];
                mapping["png-cstcfmot-v3-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "staticShelf", "photoAndCheckBoxO", "photoAndCheckBoxT", "suggestion", "thanks"];
                mapping["png-bsfmot-v3-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "photoAndCheckBoxO", "photoAndCheckBoxT", "suggestion", "thanks"];
                mapping["png-smfmot-v3-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "staticShelf", "staticGondola", "staticGsku", "suggestion", "thanks"];


                mapping["png-hs-v2-rka"] =["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "hsStaticOsd", "staticShelf", "staticGondola", "staticGsku", "photoAndNumberInputO", "photoAndNumberInputT", "suggestion", "thanks"];
                mapping["png-sm-v2-rka"] = ["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "hsStaticOsd", "staticShelf", "staticGondola", "staticGsku", "photoAndNumberInputO",  "suggestion", "thanks"];
                mapping["png-bbs-v2-rka"] = ["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "hsStaticOsd", "photoAndCheckBoxO", "staticGondola", "staticGsku", "suggestion", "thanks"];

                mapping["png-hn-bsfmot-v3-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "photoAndCheckBoxO", "photoAndCheckBoxT", "photoAndNumberInputO", "suggestion", "thanks"];
                mapping["png-hn-smfmot-v3-flagship"] =  ["startWork", "storeLocation", "storeRename", "storePhoto", "photo", "hsStaticOsd", "staticShelf", "staticGondola", "staticGsku", "suggestion", "thanks"];

                /* 浏览器测试 */
//                if (window.appContext == 'web') {
//                    $taskLoader.load('data/demo.json')
//                        .then(function(taskDetail) {
//                            $rootScope.taskDetail = taskDetail;
//                            $window.taskDetail = $rootScope.taskDetail;
//                            $window.answers = {};
//                            $window.router = mapping[dataSource];
//                            if ($window.router) {
//                                $timeout(function() {
//                                    $state.go($window.router[0]);
//                                }, 500);
//                            } else {
//                                $dialog.alert("未知的dataSource, dataSource:" + dataSource);
//                            }
//                        }, function(error) {
//                            var errorMessage = encodeURIComponent(error);
//                            console.log(errorMessage);
//                        });
//
//                    return false;
//                }

                /* Load Task Detail */
                    $taskLoader.load('data/demo.json')
                    .then(function(taskDetail) {
                        $rootScope.taskDetail = taskDetail;
                        $window.taskDetail = $rootScope.taskDetail;
                        $window.answers = {};

                        $timeout(function() {
                            // 加载Task数据成功，转到店铺定位页面
                            $contextUtils.load()
                                .then(function(answers) {
                                    console.log(answers);
                                    $rootScope.taskDetail = taskDetail;
                                    $window.taskDetail = $rootScope.taskDetail;
                                    $window.answers = {};

                                    if (answers) {
                                        if (answers && answers.answer) {
                                            $window.answers = answers.answer;
                                        } else {
                                            $window.answers = answers;
                                        }
                                    } else {
                                        $window.answers = {};
                                        $window.answers.photos = [];
                                    }

                                    $window.router = mapping[dataSource];
                                    if ($window.router) {
                                        $timeout(function() {
                                            $state.go($window.router[0]);
                                        }, 500);
                                    } else {
                                        $dialog.alert("未知的dataSource, dataSource:" + dataSource);
                                    }

                                    $state.go($window.router[0]);
                                }, function(error) {
                                    $dialog.alert(error);
                                });

                        }, 500);
                    }, function(error) {
                        var errorMessage = encodeURIComponent(error);
                        console.log(errorMessage);
                    });

        }]);

        return fmot;
});
