define(['core/controllers'],
    function(controllers) {

    console.info('AddressLocationCtrl Load!');

    controllers.controller('AddressLocationCtrl', ['$scope', '$window', '$dialog', '$gps', '$ionicLoading', '$timeout', '$state', '$stateParams',
        function($scope, $window, $dialog, $gps, $ionicLoading, $timeout, $state, $stateParams) {
            $window.stateHistory.push({ state: $state.current, params: $stateParams });

            $scope.seq = $window.currentSeq;

            $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                "点击定位获取指定地址的GPS";

            $scope.location = $window.answers[$scope.seq];

            if ($scope.location) {
                $scope.locationInfo = "经度：" + $scope.location.longitude + ", 纬度：" + $scope.location.latitude
                    + ($scope.location.address ? (", 位置：" + $scope.location.address) : "");
            }

            $scope.getLocation = function() {

                $ionicLoading.show({
                    template: '<ion-spinner icon="ios-small"></ion-spinner>'
                });

                $gps.getLocation2()
                    .then(function(location) {
                        $scope.location = location;
                        if ($scope.location) {
                            $scope.locationInfo = "经度：" + $scope.location.longitude + ", 纬度：" + $scope.location.latitude
                                + ($scope.location.address ? (", 位置：" + $scope.location.address) : "");
                        }

                        $window.answers[$scope.seq] = $scope.location;

                        $ionicLoading.show({
                            template: '<i class="icon ion-information-circled"></i>&nbsp;定位成功'
                        });

                        $timeout(function() {
                            $ionicLoading.hide();
                        }, 600);

                    }, function(error) {
                        $ionicLoading.hide();
                        $dialog.alert(error);
                    });
            };

            $scope.next = function() {
                if (!$scope.location && !$window.debugger) {
                    $dialog.alert('请先定位');
                    return false;
                }
                var currentSeq = $window.currentSeq;
                var routerSize = $window.router.length;
                if (currentSeq < (routerSize - 1)){
                    $window.currentSeq++;
                    var nextState = $window.router[$window.currentSeq];
                    $state.go(nextState);
                }
            };

            $scope.prev = function() {
                // delete $window.answers[$scope.seq];
                var currentSeq = $window.currentSeq;
                if (currentSeq != 0){
                    $window.currentSeq--;
                    var prevState = $window.router[$window.currentSeq];
                    $state.go(prevState);
                }
            };
    }]);

});