define(['core/controllers'],
    function(controllers) {
        console.info('CountCtrl Load!');

        controllers.controller('CountCtrl', ['$scope', '$rootScope', '$state', '$stateParams', '$window', '$camera', '$dialog', '$timeout', '$ionicModal', '$ionicSlideBoxDelegate',
            function($scope, $rootScope, $state, $stateParams, $window, $camera, $dialog, $timeout, $ionicModal, $ionicSlideBoxDelegate) {

                $window.stateHistory.push({ state: $state.current, params: $stateParams });
                $scope.showCrossPiece = false;
                $scope.showHcOrderCheckBox= false;
                $scope.showFcColorOrderCheckBox = false;

                $scope.seq = $stateParams.seq;
                var type = $stateParams.type;
                $scope.photos = [];
                if (dataSource == 'png-cstcfmot-flagship' || dataSource == 'png-cstcfmot-v3-flagship' || dataSource == 'png-cstcfmot-blackpin'){
                    $scope.category = $rootScope.taskDetail.cts_category;
                } else if ((dataSource == 'png-cst-drug-rka' || dataSource == 'png-cst-drug-v2-rka') && (type == 'hsStaticOsd' || type == 'staticGondola')){
                    $scope.category = $rootScope.taskDetail.cts_category;
                } else if ((dataSource == 'png-cst-drug-rka' || dataSource == 'png-cst-drug-v2-rka') && type == 'staticShelf'){
                    $scope.category = $rootScope.taskDetail.drug_category;
                }  else if ((dataSource == 'png-bbs-rka' || dataSource == 'png-bbs-v2-rka') && (type == 'hsStaticOsd' || type == 'staticGondola')){
                    $scope.category = $rootScope.taskDetail.bbs_category;
                }   else {
                    $scope.category = $rootScope.taskDetail.category;
                }

                var categoryTitle = $scope.category[$scope.seq].title;
                if ('洗发水/护发素/定型' == categoryTitle && (dataSource == 'png-hs-rka' || dataSource == 'png-hs-v2-rka') && type == 'hsStaticOsd'){
                    $scope.showHcOrderCheckBox= true;
                    $scope.checkBrand = "潘婷/沙宣/精华飘柔";
                }

                if ('洗发水/护发素/定型' == categoryTitle && (dataSource == 'png-cst-drug-rka' || dataSource == 'png-cst-drug-v2-rka') && type == 'staticShelf'){
                    $scope.showHcOrderCheckBox= true;
                    $scope.checkBrand = "潘婷/沙宣品牌产品";
                }

                if ('卫生巾/护垫' == categoryTitle && (dataSource == 'png-sm-rka' || dataSource == 'png-hs-rka' || dataSource == 'png-sm-v2-rka' || dataSource == 'png-hs-v2-rka') && type == 'staticShelf' ){
                    $scope.showFcColorOrderCheckBox= true;
                }

                if ('儿童纸尿裤' == categoryTitle && (dataSource == 'png-hsfmot-v3-flagship' || dataSource == 'png-bsfmot-v3-flagship') && type == 'staticShelf') {
                    $scope.showXPPCheckBox= true;
                }

                if ('牙膏/牙刷/牙线' == categoryTitle && dataSource == 'png-hsfmot-v3-flagship' && type == 'staticShelf') {
                    $scope.showYSYDQCheckBox= true;
                }

                if ('卫生巾/护垫' == categoryTitle && dataSource == 'png-hsfmot-v3-flagship' && type == 'staticShelf') {
                    $scope.showCPGBCheckBox= true;
                }

                if ((dataSource == 'png-smfmot-flagship' || dataSource == 'png-smfmot-blackpin') && type == 'staticShelf') {
                    $scope.showCrossPiece = true;
                }

                if ((dataSource == 'png-hsfmot-v2-flagship' || dataSource == 'png-hsfmot-v3-flagship' || dataSource == 'png-cstcfmot-v2-flagship'
                    || dataSource == 'png-cstcfmot-v3-flagship'|| dataSource == 'png-bsfmot-v2-flagship' || dataSource == 'png-bsfmot-v3-flagship'
                    || dataSource == 'png-smfmot-v2-flagship' || dataSource == 'png-smfmot-v3-flagship')
                    && type == 'staticShelf') {
                    $scope.showCrossPiece = true;
                }

                if (dataSource == 'png-hsfmot-v3-flagship' ) {
                    $scope.crossPiece = "是否有宝洁品牌的货架档条";
                } else {
                    $scope.crossPiece = "是否有挡条";
                }

                if ($window.answers[$scope.seq] == undefined) {
                    $scope.showNoDataAndBackButton = true;
                }

                if (dataSource == 'png-bbs-rka'){
                    $scope.showNBSMCheckBox= true;
                    $scope.checkBrand = "潘婷/沙宣/精华飘柔";
                }

                var backToState;
                if (type == 'hsStaticOsd') {
                    $scope.name = "堆头/包柱/立架";
                    backToState = "hsStaticOsd";
                } else if (type == 'staticShelf') {
                    $scope.name = "货架";
                    backToState = "staticShelf";
                } else if (type == 'staticGondola') {
                    if (dataSource == 'png-smfmot-v2-flagship' && dataSource == 'png-smfmot-v3-flagship') {
                        $scope.showTips = true;
                        $scope.name = "端架";
                    } else {
                        $scope.name = "端架/侧板";
                    }

                    backToState = "staticGondola";
                }
                $scope.brand = $scope.category[$scope.seq].brand;

                $scope.defaultPic = 'img/default.png';


                $scope.noPicFlag = false;
                $scope.noCrosspieceFlag = false;
                $scope.hcOrderFlag = false;
                $scope.fcColorOrderFlag = false;

                $scope.XPPFlag = false;
                $scope.YSYDQFlag = false;
                $scope.CPGBFlag = false;

                // $scope.v1 = 1; $scope.v2 = 0.5; $scope.v3 = 1; $scope.v4 = 0.5;

                $scope.chooseImage = function() {
                    var maxCount = 5 - $scope.photos.length;
                    if(maxCount == 0) {
                        $dialog.alert("最多选择5张照片");
                        return false;
                    }

                    $camera
                        .getPicture({ maxCount: maxCount, writeMetadata: false })
                        .then(function(images) {
                            _.each(images, function(image) {
                                image.checked = false;
                                if (image.imagePath.indexOf(".png") > 0 || image.imagePath.indexOf(".jpg") > 0) {
                                    image.thumbnail = image.imagePath
                                        .replace('.png','.thumbnail.png')
                                        .replace('.jpg','.thumbnail.jpg');
                                } else {
                                    image.thumbnail = image.imagePath + ".thumbnail";
                                }
                            });

                            // 最多选5张
                            $scope.photos = $scope.photos.concat(images);
                            // 只选一张
                            // $scope.photos = images;
                        }, function(error) {
                            // $dialog.alert(error);
                        });
                };

                $scope.deleteImage = function() {
                    $scope.photos = [];
                };

                $scope.back = function() {
                    $state.go(backToState);
                };

                $scope.noDataAndBack = function() {
                    var seq = $scope.seq;
                    if ($window.answers[$window.currentSeq][seq] == undefined){
                        $window.answers[$window.currentSeq][seq] = {
                            value: [0, 0],
                            history: []
                        }
                    }
                    $scope.back();
                };

                $scope.toggleNoPicFlag = function(noPicFlag, $event) {
                    $scope.noPicFlag = noPicFlag;
                    if (noPicFlag) {
                        $scope.photos = [];
                    }
                };

                $scope.toggleNoCrosspieceFlag= function(noCrosspieceFlag, $event) {
                    $scope.noCrosspieceFlag = noCrosspieceFlag;
                };

                $scope.toggleHcOrderFlag = function(hcOrderFlag, $event) {
                    $scope.hcOrderFlag = hcOrderFlag;
                };

                $scope.toggleFcColorOrderFlag= function(fcColorOrderFlag, $event) {
                    $scope.fcColorOrderFlag = fcColorOrderFlag;
                };

                $scope.toggleNBSMFlag= function(NBSMFlag, $event) {
                    $scope.NBSMFlag = NBSMFlag;
                };

                $scope.toggleXPPFlag= function(XPPFlag, $event) {
                    $scope.XPPFlag = XPPFlag;
                };


                $scope.toggleYSYDQFlag= function(YSYDQFlag, $event) {
                    $scope.YSYDQFlag = YSYDQFlag;
                };


                $scope.toggleCPGBFlag= function(CPGBFlag, $event) {
                    $scope.CPGBFlag = CPGBFlag;
                };


                /* utils */
                function getTime(format) {
                    var date = new Date();
                    var yyyy = date.getFullYear();
                    var MM = (date.getMonth() + 101 + '').slice(1);
                    var dd = (date.getDate() + 100 + '').slice(1);
                    if (format === 'yyyy-MM-dd') {
                        return yyyy + '-' + MM + '-' + dd;
                    } else if (format === 'yyyy-MM-dd hh:mm:ss') {
                        var hh = (date.getHours() + 100 + '').slice(1);
                        var mm = (date.getMinutes() + 100 + '').slice(1);
                        var ss = (date.getSeconds() + 100 + '').slice(1);
                        return yyyy + '-' + MM + '-' + dd + ' ' + hh + ':' + mm + ':' + ss;
                    }
                }

                /**
                 *
                 * @param v1 分类数
                 * @param v2 宝洁数
                 * @param seq
                 * @returns {*}
                 * @private
                 */
                function _addIncrement(v1, v2, seq) {
                    // console.log(v1, v2, seq);
                    var currentSeq = $window.currentSeq;
                    var photos = $scope.photos;
                    if (!_.isNumber(v1) || !_.isNumber(v2) || _.isNaN(v1) || _.isNaN(v2)) {
                        return '请输入数字';
                    }
                    if (v2 > v1) {
                        v2 = v1;
                        return '宝洁数不得大于分类数';
                    }
                    if (v1 == 0) {
                        return '分类数不得为0';
                    }
                    // console.log(!$scope.noPicFlag);
                    if (!$scope.noPicFlag && photos.length == 0) {
                        return '请先拍照';
                    }

                    var cateIndex = seq;
                    if ($window.answers[currentSeq] == undefined){
                        $window.answers[currentSeq] = {};
                    }

                    if ($window.answers[currentSeq][cateIndex] == undefined){
                        $window.answers[currentSeq][cateIndex] = {
                            value: [0, 0],
                            history: []
                        }
                    }

                    var photoSeq = $window.getPhotoSeq(currentSeq);
                    photoSeq = photoSeq + 10000 * seq;
                    var increment = [v1, v2];
                    var timestamp = getTime("yyyy-MM-dd hh:mm:ss");

                    if (!(v1 == 0 && v2 == 0)) {
                        $window.answers[currentSeq][cateIndex].history.push({
                            increment: increment,
                            timestamp: timestamp,
                            photoSeq: photoSeq,
                            noCrosspieceFlag:$scope.getNoCrosspieceFlag(),
                            hcOrderFlag: $scope.getHcOrderFlag(),
                            fcColorOrderFlag: $scope.getFcColorOrderFlag(),
                            NBSMFlag:$scope.getNBSMFlag(),
                            XPPFlag:$scope.getXPPFlag(),
                            YSYDQFlag:$scope.getYSYDQFlag(),
                            CPGBFlag:$scope.getCPGBFlag()
                        });
                    }

                    //};

                    $window.answers[currentSeq][cateIndex].value[0] = parseFloat($window.answers[currentSeq][cateIndex].value[0]) + v1;
                    $window.answers[currentSeq][cateIndex].value[0] = $window.answers[currentSeq][cateIndex].value[0].toFixed(1);

                    $window.answers[currentSeq][cateIndex].value[1] = parseFloat($window.answers[currentSeq][cateIndex].value[1]) + v2;
                    $window.answers[currentSeq][cateIndex].value[1] = $window.answers[currentSeq][cateIndex].value[1].toFixed(1);

                    if ($scope.answers) {
                        $scope.category[cateIndex].totalCount = $window.answers[currentSeq][cateIndex].value[0];
                        $scope.category[cateIndex].pngCount = $window.answers[currentSeq][cateIndex].value[1];
                        $scope.category[cateIndex].hasData = true;
                    } else {
                        $scope.category[cateIndex].totalCount = 0;
                        $scope.category[cateIndex].pngCount = 0;
                        $scope.category[cateIndex].hasData = false;
                    }

                    /* 照片 */
                    if ($window.answers[photoSeq] == undefined) {
                        $window.answers[photoSeq] = [];
                    }

                    if (photos.length > 0) {
                        if (_.indexOf($window.answers.photos, parseInt(photoSeq)) == -1){
                            $window.answers.photos.push(parseInt(photoSeq));
                        }
                        $window.answers[photoSeq] = $window.answers[photoSeq].concat(photos);
                    }

                    //再次验证图片数量
                    if (!$scope.noPicFlag && $window.answers[photoSeq].length == 0) {
                        return '请先拍照';
                    }

                    return '';
                }

                $scope.addIncrement = function(v1, v2) {
                    var seq = $scope.seq;
                    var err = _addIncrement(v1, v2, seq);
                    if (err != '') {
                        $dialog.alert(err);
                        return false;
                    }
                    $scope.back();
                };

                /* view pic */
                $ionicModal.fromTemplateUrl('views/photoSlideBox.html', {
                    scope: $scope,
                    animate: 'slide-in-up'
                }).then(function(modal){
                    $scope.modal = modal;
                });

                $scope.openPhotoSlideModal = function() {
                    var imgs = [];
                    _.each($scope.photos, function(photo) {
                        imgs.push(photo.imagePath);
                    });
                    $scope.imgs = imgs;
                    if ($scope.imgs.length > 0) {
                        $scope.modal.show();
                        $ionicSlideBoxDelegate.update();
                        $timeout(function() {
                            $ionicSlideBoxDelegate.slide(0);
                        });
                    }
                };
                $scope.closePhotoSlideModal = function() {
                    $scope.modal.hide();
                    $scope.imgs = [];
                };
                //Cleanup the modal when we're done with it!
                $scope.$on('$destroy', function() {
                    $scope.modal.remove();
                });

                $scope.getTimeGap = function(timestamp) {
                    var date = new Date();
                    var yyyy = parseInt(timestamp.substr(0, 4));
                    var MM = parseInt(timestamp.substr(5, 2)) - 1;
                    var dd = parseInt(timestamp.substr(8, 2));
                    var hh = timestamp.substr(11, 2);
                    var mm = timestamp.substr(14, 2);
                    var ss = timestamp.substr(17, 2);
                    date.setFullYear(yyyy);
                    date.setMonth(MM);
                    date.setDate(dd);
                    date.setHours(hh);
                    date.setMinutes(mm);
                    date.setSeconds(ss);
                    var gap = (new Date() - date)/(1000 * 60);
                    // console.log(gap );
                    if (gap < 1) {
                        return "小于1分钟前"
                    } else if (gap >= 1 && gap <= 59) {
                        return gap.toFixed(0) + "分钟前"
                    } else if (gap >= 60 && gap < 60*24) {
                        return "约" + (gap/60).toFixed(0) + "小时前"
                    } else {
                        return (gap/(60*24)).toFixed(0) + "天前"
                    }
                }

                $scope.getNoCrosspieceFlag = function(){
                    return $scope.noCrosspieceFlag?1:0;
                };

                $scope.getHcOrderFlag= function(){
                    return $scope.hcOrderFlag?1:0;
                };

                $scope.getFcColorOrderFlag = function(){
                    return $scope.fcColorOrderFlag?1:0;
                };

                $scope.getNBSMFlag = function(){
                    return $scope.NBSMFlag?1:0;
                };

                $scope.getXPPFlag= function(){
                    return $scope.XPPFlag?1:0;
                };

                $scope.getYSYDQFlag = function(){
                    return $scope.YSYDQFlag?1:0;
                };

                $scope.getCPGBFlag = function(){
                    return $scope.CPGBFlag?1:0;
                };

            }]);
    });
