define(['core/controllers'], function(controllers) {
    console.info('CountCtrl Load!');

    controllers.controller('CountHistCtrl', ['$scope', '$rootScope', '$state', '$stateParams', '$window', '$camera', '$dialog', '$ionicModal', '$ionicSlideBoxDelegate', '$timeout',
        function ($scope, $rootScope, $state, $stateParams, $window, $camera, $dialog, $ionicModal, $ionicSlideBoxDelegate, $timeout) {

            $window.stateHistory.push({ state: $state.current, params: $stateParams });

            $scope.seq = $stateParams.seq;
            var type = $stateParams.type;

            var backToState;
            if (type == 'hsStaticOsd') {
                $scope.name = "堆头/包柱";
                backToState = "hsStaticOsd";
            } else if (type == 'staticShelf') {
                $scope.name = "货架";
                backToState = "staticShelf";
            } else if (type == 'staticGondola') {
                $scope.name = "端架";
                backToState = "staticGondola";
            }

            var cateIndex = $scope.seq;

            $scope.cateIndex = cateIndex;

            $scope.answer = $window.answers[$window.currentSeq][$scope.cateIndex];
            $scope.history = $scope.answer.history;
            $scope.ttl = $scope.answer.value;

            $scope.defaultPic = 'img/default.png';

            $scope.thumbnails = [];
            _updateThumbnails();

            $scope.deleteHist = function(histIndex) {
                $dialog.confirm("确定删除该条记录？", "提示", "确定", "取消").then(function (confirmed) {
                    if (confirmed) {
                        var photoSeq = $scope.history[histIndex].photoSeq;
                        delete $window.answers[photoSeq];
                        var deleted = $scope.history.splice(histIndex, 1);
                        $scope.ttl[0] -= deleted[0].increment[0];
                        $scope.ttl[0] = parseFloat($scope.ttl[0]).toFixed(1);
                        if ($scope.ttl[0] == 0.0) $scope.ttl[0] = 0;
                        $scope.ttl[1] -= deleted[0].increment[1];
                        $scope.ttl[1] = parseFloat($scope.ttl[1]).toFixed(1);
                        if ($scope.ttl[1] == 0.0) $scope.ttl[1] = 0;

                        $scope.thumbnails.splice(histIndex, 1);
                        // _updateThumbnails();
                    }
                }, function () {

                });
            };

            $scope.back = function() {
                //$window.answers[$scope.seq] = $scope.answer;
                $window.answers[$window.currentSeq][$scope.cateIndex] =  $scope.answer;
                $state.go(backToState);
            };

            function _updateThumbnails() {
                $scope.thumbnails = [];
                _.each($scope.history, function(hist) {
                    var photos = $window.answers[hist.photoSeq] || [];
                    // 每条记录1张图片
                    // $scope.thumbnails.push((photos[0] && photos[0].thumbnail) || 'img/default.png');
                    // 每条记录多张图片
                    var _array = [];
                    _.each(photos, function(photo) {
                        _array.push((photo && photo.thumbnail) || 'img/default.png');
                    });
                    $scope.thumbnails.push(_array);
                });
            }

            /* view pic */
            $ionicModal.fromTemplateUrl('views/photoSlideBox.html', {
                scope: $scope,
                animate: 'slide-in-up'
            }).then(function(modal){
                $scope.modal = modal;
            });

            $scope.openPhotoSlideModal = function(index) {
                $scope.imgs = $scope.thumbnails[index];
                if ($scope.imgs.length > 0) {
                    $scope.modal.show();
                    $ionicSlideBoxDelegate.update();
                    $timeout(function() {
                        $ionicSlideBoxDelegate.slide(0);
                    });
                }
            };
            $scope.closePhotoSlideModal = function() {
                $scope.modal.hide();
                $scope.imgs = [];
            };
            //Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });

            $scope.getTimeGap = function(timestamp) {
                var date = new Date();
                var yyyy = parseInt(timestamp.substr(0, 4));
                var MM = parseInt(timestamp.substr(5, 2)) - 1;
                var dd = parseInt(timestamp.substr(8, 2));
                var hh = timestamp.substr(11, 2);
                var mm = timestamp.substr(14, 2);
                var ss = timestamp.substr(17, 2);
                date.setFullYear(yyyy);
                date.setMonth(MM);
                date.setDate(dd);
                date.setHours(hh);
                date.setMinutes(mm);
                date.setSeconds(ss);
                var gap = (new Date() - date)/(1000 * 60);
                // console.log(gap );
                if (gap < 1) {
                    return "小于1分钟前"
                } else if (gap >= 1 && gap <= 59) {
                    return gap.toFixed(0) + "分钟前"
                } else if (gap >= 60 && gap < 60*24) {
                    return "约" + (gap/60).toFixed(0) + "小时前"
                } else {
                    return (gap/(60*24)).toFixed(0) + "天前"
                }
            }

        }]);

});