define(['core/controllers'],
    function(controllers) {
        console.info('GeneralStaticController Load!');

        controllers.controller('GeneralStaticCtrl', ['$scope', '$rootScope', '$window', '$dialog', '$state', '$ionicModal', '$ionicLoading', '$ionicPopup', '$ionicPopover', '$timeout', '$stateParams', '$contextUtils',
            function($scope, $rootScope, $window, $dialog, $state, $ionicModal, $ionicLoading, $ionicPopup, $ionicPopover, $timeout, $stateParams, $contextUtils) {
                var picInfo;
                $window.stateHistory.push({ state: $state.current, params: $stateParams });

                var currentUrl = $state.current.url ;
                if (currentUrl == '/hsStaticOsd') {
                    $scope.name = '堆头/包柱/立架';
                    picInfo = $rootScope.taskDetail.picInfo['osd'];
                } else if (currentUrl == '/staticShelf') {
                    $scope.name = '货架';
                    picInfo = $rootScope.taskDetail.picInfo['shelf'];
                } else { // currentUrl == '/staticGondola'
                    if (dataSource == 'png-smfmot-v2-flagship' || dataSource == 'png-smfmot-v3-flagship') {
                        $scope.name = "端架";
                    } else {
                        $scope.name = "端架/侧板";
                    }

                    picInfo = $rootScope.taskDetail.picInfo['shelf'];
                    var pic1 = {"image": "img/pc_1.png", "label": "形象堆头"};
                    picInfo.pics.push(pic1);

                    var pic2 = {"image": "img/pc_2.png", "label": "端架侧板"};
                    picInfo.pics.push(pic2);

                    var pic3 = {"image": "img/pc_3.png", "label": "立架"};
                    picInfo.pics.push(pic3);
                }

                if ((dataSource == 'png-hs-rka' || dataSource == 'png-hs-v2-rka') && currentUrl == '/hsStaticOsd'){
                    if (picInfo.pics.length == 2){
                        var pic = {"image": "img/hc_osd.png", "label": "潘婷/沙宣/精华飘柔堆头连带陈列"};
                        picInfo.pics.push(pic);
                    }
                } else if ((dataSource == 'png-cst-drug-rka' || dataSource == 'png-cst-drug-v2-rka') && currentUrl == '/staticShelf'){

                } else if ((dataSource == 'png-sm-rka' || dataSource == 'png-hs-rka' || dataSource == 'png-sm-v2-rka' || dataSource == 'png-hs-v2-rka') && currentUrl == '/staticShelf' ){
                    if (picInfo.pics.length == 3) {
                        var pic = {"image": "img/fc_osd.png", "label": "卫生巾从左自右粉蓝黑摆放"};
                        picInfo.pics.push(pic);
                    }
                } else if (dataSource == 'png-hsfmot-v3-flagship'  && currentUrl == '/staticShelf' ){
                    if (picInfo.pics.length == 3) {
                        var pic1 = {"image": "img/xpp.png", "label": "小屁股演示工具"};
                        var pic2 = {"image": "img/cpgb.png", "label": "护舒宝产品挂板"};
                        var pic3 = {"image": "img/ysydq.png", "label": "牙刷引导器"};
                        picInfo.pics.push(pic1);
                        picInfo.pics.push(pic2);
                        picInfo.pics.push(pic3);
                    }
                }

                $scope.picInfo = picInfo;
                $scope.curSeq = -1;

                if (dataSource == 'png-cstcfmot-flagship' || dataSource == 'png-cstcfmot-v3-flagship'  || dataSource == 'png-cstcfmot-blackpin'){
                    $scope.category = $rootScope.taskDetail.cts_category;
                } else if ((dataSource == 'png-cst-drug-rka'  || dataSource == 'png-cst-drug-v2-rka') && (currentUrl == '/hsStaticOsd' || currentUrl == '/staticGondola')){
                    $scope.category = $rootScope.taskDetail.cts_category;
                } else if ((dataSource == 'png-cst-drug-rka' || dataSource == 'png-cst-drug-v2-rka') && currentUrl == '/staticShelf'){
                    $scope.category = $rootScope.taskDetail.drug_category;
                } else if((dataSource == 'png-bbs-rka' || dataSource == 'png-bbs-v2-rka') && (currentUrl == '/hsStaticOsd' || currentUrl == '/staticGondola')){
                    $scope.category = $rootScope.taskDetail.bbs_category;
                } else {
                    $scope.category = $rootScope.taskDetail.category;
                }


                $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                    "按以下分类统计<span class='color-assertive'>" +
                    $scope.name + "</span>数量";

                if ($stateParams.showTips == 1) {
                    $ionicLoading.show({
                        template: '<p>请先找到卖场的日化品区，<br>并大致确定' + $scope.name + '的位置</p>'
                    });

                    $timeout(function() {
                        $ionicLoading.hide();
                    }, 5000);
                }

                // console.log('calc cate.png & cate.ttl');

                function updateCategories() {
                    _.each($scope.category, function(item, seq) {
                        if ($window.answers[currentSeq] == undefined){
                            $window.answers[currentSeq] = {};
                        }
                        if ($window.answers[currentSeq][seq]) {
                            $scope.category[seq].totalCount = $window.answers[$window.currentSeq][seq].value[0];
                            $scope.category[seq].pngCount =$window.answers[$window.currentSeq][seq].value[1];
                            $scope.category[seq].hasData = true;
                        } else {
                            $scope.category[seq].totalCount = 0;
                            $scope.category[seq].pngCount = 0;
                            $scope.category[seq].hasData = false;
                        }
                    });
                }

                updateCategories();

                /* 计数 */
                $scope.count = function(index) {
                    var type = $scope.getStatsType();
                    $state.go('count', { seq: index , type: type});
                };

                /* 查看统计历史记录 */
                $scope.review = function(index) {
                    var type = $scope.getStatsType();
                    $state.go('countHist', { seq: index , type: type});
                };

                /*获取统计类型*/
                $scope.getStatsType = function(){
                    var currentUrl = $state.current.url;
                    if (currentUrl == '/hsStaticOsd') {
                        return "hsStaticOsd";
                    } else if (currentUrl == '/staticShelf') {
                        return "staticShelf";
                    } else { // currentUrl == '/staticGondola'
                        return "staticGondola";
                    }
                };

                /* 确认无此分类 */
                $scope.confirmNoData = function(seq) {
                    var cateIndex = seq;
                    $window.answers[currentSeq][cateIndex] = {
                        value: [0, 0],
                        history: []
                    }
                    updateCategories();
                };

                $scope.next = function() {
                    $contextUtils.save($window.answers);
                    if ($scope.validate() > 0  && !$window.debugger){
                        $dialog.alert("数据不完整，您有" + $scope.validate() + "个分类未确认" + $scope.name + "数量，请在【添加" + $scope.name + "数量】页面中添加" +$scope.name + "数量，" +
                            "或者在【统计" + $scope.name + "数量】页面中，点击【确认无此分类" + $scope.name + "】进行确认。");
                        return;
                    }

                    var currentSeq = $window.currentSeq;
                    var routerSize = $window.router.length;
                    if (currentSeq < (routerSize - 1)){
                        $window.currentSeq++;
                        var nextState = $window.router[$window.currentSeq];
                        $state.go(nextState);
                    }
                };

                $scope.prev = function() {
                    var currentSeq = $window.currentSeq;
                    if (currentSeq != 0){
                        $window.currentSeq--;
                        var prevState = $window.router[$window.currentSeq];
                        $state.go(prevState);
                    }
                };

                $scope.validate = function(){
                    var result = _.filter($scope.category , function(item, seq) {
                        return  $window.answers[currentSeq][seq] == undefined;
                    });
                    return result.length;
                };

                $ionicModal.fromTemplateUrl('views/pic.html', {
                    scope: $scope,
                    animate: 'slide-in-up'
                }).then(function(modal){
                    $scope.modal = modal;
                });

                $scope.openPicModal = function() {
                    $scope.modal.show();
                };
                $scope.closePicModal = function() {
                    $scope.modal.hide();
                };
                //Cleanup the modal when we're done with it!
                $scope.$on('$destroy', function() {
                    $scope.modal.remove();
                });

                $scope.save = function() {
                    $contextUtils.save($window.answers);
                };
        }]);

});
