define(['core/controllers'],
    function(controllers) {
        console.info('GskuStaticController Load!');

        controllers.controller('GskuStaticCtrl', ['$scope', '$rootScope', '$window', '$dialog', '$state', '$stateParams',
            function($scope, $rootScope, $window, $dialog, $state, $stateParams) {
                $window.stateHistory.push({ state: $state.current, params: $stateParams });

                $scope.curSeq = -1;
                if (dataSource == 'png-cstcfmot-flagship' || dataSource == 'png-cstcfmot-blackpin'){
                    $scope.category = $rootScope.taskDetail.cts_category;
                } else if(dataSource == 'png-bsfmot-blackpin') {
                    $scope.category = $rootScope.taskDetail.bbs_category;
                }  else if((dataSource == 'png-cst-drug-rka' || dataSource == 'png-cst-drug-v2-rka')) {
                    $scope.category = $rootScope.taskDetail.cts_category;
                }  else if(dataSource == 'png-bbs-rka' || dataSource == 'png-bbs-v2-rka') {
                    $scope.category = $rootScope.taskDetail.bbs_category;
                }  else {
                    $scope.category = $rootScope.taskDetail.category;
                }


                $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                    "按以下分类和品牌统计<span class='color-assertive'>GSKU</span>数量";

                var allBrands = [];
                _.each($scope.category, function(cate, cateIndex) {
                    cate.brand[0].cateTitle = cate.title;
                    _.each(cate.brand, function(b, brandIndex) {
                        b.cateIndex = cateIndex;
                        b.brandIndex = brandIndex;
                    });
                    allBrands = allBrands.concat(cate.brand);
                });
                $scope.allBrands = allBrands;

                $scope.answers = {};

                _.each($scope.category, function(item, seq) {
                    if ($window.answers[$window.currentSeq]) {
                        $scope.answers[seq] = $window.answers[$window.currentSeq][seq];
                    } else {
                        var len = $scope.category[seq].brand.length;
                        var brandList = [];
                        for (var i = 0; i < len; i++) {
                            brandList.push(null);
                        }

                        $scope.answers[seq] = {
                            value: 0,
                            brandList: brandList
                        };
                    }
                });

                $scope.change = function(value, cateIndex, brandIndex) {
                    console.log(value, cateIndex, brandIndex);
                    // console.log($scope.answers[cateIndex + 24].brandList);

                    // to nothing, for monitor
                    //console.log( $scope.answers )

                };

                $scope.saveAllSkuCount = function() {
                    // calc total count by category
                    _.each($scope.answers, function(answer) {
                        // reset total count
                        answer.value = 0;
                        _.each(answer.brandList, function(cnt, i) {
                            if (cnt==null) answer.brandList[i] = 0;
                            answer.value += cnt;
                        });
                        // console.log(answer);
                    });

                    _.each($scope.seqs, function(seq) {
                        $scope.answers[seq] = $scope.answers[seq];
                    });
                    $window.answers[$window.currentSeq] = $scope.answers;
                };

                $scope.prev = function() {
                    var currentSeq = $window.currentSeq;
                    if (currentSeq != 0){
                        $window.currentSeq--;
                        var prevState = $window.router[$window.currentSeq];
                        $state.go(prevState);
                    }
                };

                $scope.next = function() {
                    $scope.saveAllSkuCount();
                    var currentSeq = $window.currentSeq;
                    var routerSize = $window.router.length;
                    if (currentSeq < (routerSize - 1)){
                        $window.currentSeq++;
                        var nextState = $window.router[$window.currentSeq];
                        $state.go(nextState);
                    }
                };
        }]);

});
