define(['core/controllers'],
    function(controllers) {

    console.info('IssueCtrl Load!');

    controllers.controller('IssueCtrl', ['$scope', '$window', '$q', '$state', '$dialog', '$stateParams',
        function($scope, $window, $q, $state, $dialog, $stateParams) {

            $window.stateHistory.push({ state: $state.current, params: $stateParams });

            $scope.seq = $window.currentSeq;

            $scope.answer = $window.answers[$scope.seq];
            $scope.issueType = $scope.answer && $scope.answer.value;

            $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" + "具体遇到什么问题？";
            $scope.options = [
                '店家拒访',
                '店铺当天歇业或装修中',
                '店铺已倒闭',
                '指定地址无此店铺',
                '指定地址详细，但无法找到',
                '指定地址模糊，无法找到',
                '其他'
            ];

            $scope.chooseOption = function(option) {
                $scope.issueType = option;
                $scope.answer = {
                    value: option,
                    text: $scope.options[$scope.issueType]
                }
            };

            $scope.next = function() {
                if (!$scope.answer  && !$window.debugger) {
                    $dialog.alert("请先答题");
                    return false;
                }
                $window.answers[$scope.seq] = $scope.answer;
                var currentSeq = $window.currentSeq;
                var routerSize = $window.router.length;
                if (currentSeq < (routerSize - 1)){
                    $window.currentSeq++;
                    var nextState = $window.router[$window.currentSeq];
                    $state.go(nextState);
                }
            };

            $scope.prev = function() {
                // 删除答案
                var currentSeq = $window.currentSeq;
                if (currentSeq != 0){
                    $window.currentSeq--;
                    var prevState = $window.router[$window.currentSeq];
                    $state.go(prevState);
                }
            };

    }]);

});