define(['core/controllers'],
    function(controllers) {

    console.info('IssueDescCtrl Load!');

    controllers.controller('IssueDescCtrl', ['$scope', '$window', '$q', '$state', '$dialog', '$stateParams',
        function($scope, $window, $q, $state, $dialog, $stateParams) {

            $window.stateHistory.push({ state: $state.current, params: $stateParams });

            $scope.seq =  $window.currentSeq;

            console.debug('seq: ' + $scope.seq, 'IssueDescCtrl');

            $scope.answer = $window.answers[$scope.seq];

            $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                "请详细描述您无法执行差事的原因";

            $scope.change = function(answer) {
                $scope.answer = answer;
            };

            $scope.next = function() {
                if (!$scope.answer  && !$window.debugger) {
                    $dialog.alert("请先答题");
                    return false;
                }
                $window.answers[$scope.seq] = $scope.answer;
                var currentSeq = $window.currentSeq;
                var routerSize = $window.router.length;
                if (currentSeq < (routerSize - 1)){
                    $window.currentSeq++;
                    var nextState = $window.router[$window.currentSeq];
                    $state.go(nextState);
                }
            };

            $scope.prev = function() {
                // 删除答案
                var currentSeq = $window.currentSeq;
                if (currentSeq != 0){
                    $window.currentSeq--;
                    var prevState = $window.router[$window.currentSeq];
                    $state.go(prevState);
                }
            };

    }]);

});