define(['core/controllers'],
    function(controllers) {
        console.info('PhotoCtrl Load!');

        controllers.controller('PhotoCtrl', ['$scope', '$rootScope', '$window', '$q', '$state', '$camera', '$dialog', '$stateParams', '$ionicModal',
            function($scope, $rootScope, $window, $q, $state, $camera, $dialog, $stateParams, $ionicModal) {
                $scope.footerType = 1;
                $window.stateHistory.push({ state: $state.current, params: $stateParams });
                $scope.seq = $stateParams.fromSeq;
                //$scope.picInfo = $rootScope.taskDetail.picInfo['osd'];
                if ($window.answers[$window.currentSeq]){
                    var answer = $window.answers[$window.currentSeq];
                    $scope.photos =  $window.answers[answer.photoSeq]?$window.answers[answer.photoSeq]:[];
                    $scope.photoSeq = answer.photoSeq;
                    var total = $scope.photos.length + 1;
                    $scope.pageSize = total % 3 == 0 ? Math.floor(total / 3) : Math.floor(total / 3) + 1;
                    $scope.lastPageItemTotal = total % 3 == 0 ? 3 : total % 3;
                } else {
                    $scope.photos = [];
                    $scope.photoSeq = -1;
                    $scope.pageSize = 1;
                    $scope.lastPageItemTotal = 1;
                }

                if (dataSource == 'png-hsfmot-v3-flagship' || dataSource == 'png-cstcfmot-v3-flagship' || dataSource == 'png-cst-drug-v2-rka'
                    || dataSource == 'png-smfmot-v3-flagship' || dataSource == 'png-bsfmot-v3-flagship' || dataSource == 'png-hn-bsfmot-v3-flagship'
                    || dataSource == 'png-hn-smfmot-v3-flagship' || dataSource == 'png-hs-v2-rka' || dataSource == 'png-sm-v2-rka' || dataSource == 'png-bbs-v2-rka'){
                    $scope.name = "主通道全景照片";
                    $scope.validateStr = "拍摄主通道全景照片";
                    $scope.description = "请从不同的角度清晰地拍摄多张以上店铺内部各主通道全景照片，照片需要能清楚的展现店内有无堆头包柱等促销陈列（至少1张最多20张）";
                    $scope.showCheckBox = false;
                }

                $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                    $scope.name;
                $scope.chooseImage = function() {
                    var maxCount = 10 - $scope.photos.length;
                    if (dataSource == 'png-hsfmot-v3-flagship' || dataSource == 'png-cstcfmot-v3-flagship' || dataSource =='png-cst-drug-v2-rka'
                        || dataSource == 'png-smfmot-v3-flagship' || dataSource == 'png-bsfmot-v3-flagship'
                        || dataSource == 'png-hs-v2-rka' || dataSource == 'png-sm-v2-rka' || dataSource == 'png-bbs-v2-rka'){
                        maxCount =  20 - $scope.photos.length;
                    }
                    if(maxCount == 0) {
                        if (dataSource == 'png-hsfmot-v3-flagship' || dataSource == 'png-cstcfmot-v3-flagship'|| dataSource =='png-cst-drug-v2-rka'
                            || dataSource == 'png-smfmot-v3-flagship' || dataSource == 'png-bsfmot-v3-flagship'
                            || dataSource == 'png-hs-v2-rka' || dataSource == 'png-sm-v2-rka' || dataSource == 'png-bbs-v2-rka'){
                            $dialog.alert("最多选择20张照片");
                        } else {
                            $dialog.alert("最多选择10张照片");
                        }
                        return false;
                    }

                    $camera
                        .getPicture({ maxCount: maxCount, writeMetadata: false })
                        .then(function(images) {
                            _.each(images, function(image) {
                                image.checked = false;
                                if (image.imagePath.indexOf(".png") > 0 || image.imagePath.indexOf(".jpg") > 0) {
                                    image.thumbnail = image.imagePath
                                        .replace('.png','.thumbnail.png')
                                        .replace('.jpg','.thumbnail.jpg');
                                } else {
                                    image.thumbnail = image.imagePath + ".thumbnail";
                                }
                            });
                            $scope.photos = $scope.photos.concat(images);
                            var total = $scope.photos.length + 1;
                            $scope.pageSize = total % 3 == 0 ? Math.floor(total / 3) : Math.floor(total / 3) + 1;
                            $scope.lastPageItemTotal = total % 3 == 0 ? 3 : total % 3;
                        }, function(error) {
                            console.log(error);
                            // $dialog.alert(error);
                        });
                };

                $scope.toggleNoCrosspieceFlag= function(noCrosspieceFlag, $event) {
                    $scope.noCrosspieceFlag = noCrosspieceFlag;
                };

                $scope.deleteImage = function() {
                    var photos = _.filter($scope.photos, function(photo) {
                        return !photo.checked;
                    });

                    if (photos.length == $scope.photos.length) {
                        $dialog.alert("请先点选要删除的照片");
                    }

                    $scope.photos = photos;
                    var total = $scope.photos.length + 1;
                    $scope.pageSize = total % 3 == 0 ? Math.floor(total / 3 ) : Math.floor(total / 3) + 1;
                    $scope.lastPageItemTotal = total % 3 == 0 ? 3 : total % 3;
                };

                $scope.clickImage = function(photoIndex) {
                    $scope.photos[photoIndex].checked = !$scope.photos[photoIndex].checked;
                };

                $scope.next = function() {
                    if ($scope.photos.length == 0  && !$window.debugger) {
                        $dialog.alert("请" + $scope.validateStr);
                        return false;
                    }
                    $scope.saveAnswer();
                    var currentSeq = $window.currentSeq;
                    var routerSize = $window.router.length;
                    if (currentSeq < (routerSize - 1)){
                        $window.currentSeq++;
                        var nextState = $window.router[$window.currentSeq];
                        $state.go(nextState);
                    }
                };

                $scope.toggleFlag = function(){
                    if($scope.isChecked){
                        $scope.isChecked = false;
                    } else {
                        $scope.isChecked = true;
                    }
                };

                $scope.saveAnswer = function(){
                    var photoSeq = $scope.photoSeq==-1 ? $window.getPhotoSeq($window.currentSeq):$scope.photoSeq;
                    /* 照片 */
                    if ($scope.photos.length > 0) {
                        if (_.indexOf($window.answers.photos, parseInt(photoSeq)) == -1){
                            $window.answers.photos.push(parseInt(photoSeq));
                        }
                        $window.answers[photoSeq] = $scope.photos;
                    }
                    var flag = $scope.isChecked ? 1 : 0;
                    var answer = {
                        photoSeq: photoSeq,
                        flag: flag,
                        noCrosspieceFlag:$scope.getNoCrosspieceFlag()
                    }
                    $window.answers[$window.currentSeq] = answer;
                };

                $scope.getNoCrosspieceFlag = function(){
                    return $scope.noCrosspieceFlag?1:0;
                };

                $scope.prev = function() {
                    var currentSeq = $window.currentSeq;
                    if (currentSeq != 0){
                        $window.currentSeq--;
                        var prevState = $window.router[$window.currentSeq];
                        $state.go(prevState);
                    }
                };

                $ionicModal.fromTemplateUrl('views/pic.html', {
                    scope: $scope,
                    animate: 'slide-in-up'
                }).then(function(modal){
                    $scope.modal = modal;
                });

                $scope.openPicModal = function() {
                    $scope.modal.show();
                };
                $scope.closePicModal = function() {
                    $scope.modal.hide();
                };
                //Cleanup the modal when we're done with it!
                $scope.$on('$destroy', function() {
                    $scope.modal.remove();
                });

                //$scope.$watch('photos', function(newValue, oldValue) {
                //    $window.answers[$scope.seq] = newValue;
                //});

            }])
            .filter('range', function() {
                return function(input, total) {
                    total = parseInt(total);
                    for (var i=0; i<total; i++)
                        input.push(i);
                    return input;
                };
            });;

    });
