define(['native/dialog', 'native/camera', 'native/gps', 'utils/taskLoader', 'utils/contextUtils'],
    function(Dialog, Camera, GPS, TaskLoader, ContextUtils) {
        console.info("Services Module Load!");

        return angular.module('services', [])

            .factory('$dialog', ['$q', '$ionicPopup', function($q, $ionicPopup) {
                var deps = {
                    $q: $q,
                    $ionicPopup: $ionicPopup
                };
                return new Dialog(deps);
            }])

            .factory('$camera', ['$q', function($q) {
                return new Camera($q);
            }])

            .factory('$gps', ['$q', '$http', function($q, $http) {
                var deps = {
                    $q: $q,
                    $http: $http
                };
                return new GPS(deps);
            }])

            .factory('$taskLoader', ['$q', '$http', function($q, $http) {
                var deps = {
                    $q: $q,
                    $http: $http
                };
                return new TaskLoader(deps);
            }])

            .factory('$contextUtils', ['$q', function($q) {
                var deps = { $q: $q };
                return new ContextUtils(deps);
            }])

            ;

});