define(['core/controllers'],
    function(controllers) {

    console.info('StartWorkCtrl Load!');

    controllers.controller('StartWorkCtrl', ['$scope', '$window', '$q', '$state', '$dialog', '$stateParams',
        function($scope, $window, $q, $state, $dialog, $stateParams) {
            console.log($state);
            $window.stateHistory.push({ state: $state.current, params: $stateParams });

            $scope.seq =  $window.currentSeq;
            $scope.answer = $window.answers[$scope.seq];
            $scope.hasExecutionIssue = ($scope.answer && $scope.answer.value);

            $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                "是否可以顺利执行该店铺差事？";
            $scope.options = ['可以顺利执行', '遇到问题'];

            $scope.chooseOption = function(option) {
                $scope.hasExecutionIssue = option;
                $scope.answer = {
                    value: option,
                    text: $scope.options[$scope.hasExecutionIssue]
                }
            };

            $scope.next = function() {
                if (!$scope.answer) {
                    $dialog.alert("请先答题");
                    return false;
                }
                if ($scope.hasExecutionIssue) {
                    // 清空答案
                    if ($window.answers && !window.answers.hasExecutionIssue) {
                        $window.answers = {version:  $window.version };
                    }

                    $window.answers[$scope.seq] = $scope.answer;
                    $window.answers.photos = [];
                    $window.router = $window.issuerouter;
                } else {
                    if ($window.answers && window.answers.hasExecutionIssue) {
                        $window.answers = {version:  $window.version };
                    }
                    $window.answers[$scope.seq] = $scope.answer;
                }

                $window.answers.hasExecutionIssue = $scope.hasExecutionIssue;
                var currentSeq = $window.currentSeq;
                var routerSize = $window.router.length;
                if (currentSeq < (routerSize - 1)){
                    $window.currentSeq++;
                    var nextState = $window.router[$window.currentSeq];
                    $state.go(nextState);
                }
            };

    }]);

});