define(['core/controllers'],
    function(controllers) {
        console.info('StoreNearbyPhotoCtrl Load!');

        controllers.controller('StoreNearbyPhotoCtrl', ['$scope', '$rootScope', '$window', '$q', '$state', '$camera', '$dialog', '$stateParams',
            function($scope, $rootScope, $window, $q, $state, $camera, $dialog, $stateParams) {

                $window.stateHistory.push({ state: $state.current, params: $stateParams });

                $scope.seq = $window.currentSeq;

                console.debug('seq: ' + $scope.seq, 'StoreNearbyPhotoCtrl');

                // 作为答案的照片
                $scope.photos = $window.answers[$scope.seq] ? $window.answers[$scope.seq] : [];
                var total = $scope.photos.length + 1;
                $scope.pageSize = total % 3 == 0 ? Math.floor(total / 3) : Math.floor(total / 3) + 1;
                $scope.lastPageItemTotal = total % 3 == 0 ? 3 : total % 3;

                $scope.validateStr = "拍摄指定地址门牌照片";

                $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                    $scope.validateStr;

                $scope.description = "如找不到指定地址，可拍摄附近门牌或路牌照片，以证明您到过指定地址附近";

                $scope.footerType = 1;

                $scope.chooseImage = function() {
                    if (dataSource == 'png-hsfmot-v3-flagship' || dataSource == 'png-cstcfmot-v3-flagship'|| dataSource =='png-cst-drug-v2-rka'
                        || dataSource == 'png-smfmot-v3-flagship' || dataSource == 'png-bsfmot-v3-flagship'
                        || dataSource == 'png-hs-v2-rka' || dataSource == 'png-sm-v2-rka' || dataSource == 'png-bbs-v2-rka') {
                        var maxCount = 4 - $scope.photos.length;
                        if(maxCount == 0) {
                            $dialog.alert("最多选择4张照片");
                            return false;
                        }
                    } else {
                        var maxCount = 2 - $scope.photos.length;
                        if(maxCount == 0) {
                            $dialog.alert("最多选择2张照片");
                            return false;
                        }
                    }
                    $camera
                        .getPicture({ maxCount: maxCount, writeMetadata: false })
                        .then(function(images) {
                            _.each(images, function(image) {
                                image.checked = false;
                                if (image.imagePath.indexOf(".png") > 0 || image.imagePath.indexOf(".jpg") > 0) {
                                    image.thumbnail = image.imagePath
                                        .replace('.png','.thumbnail.png')
                                        .replace('.jpg','.thumbnail.jpg');
                                } else {
                                    image.thumbnail = image.imagePath + ".thumbnail";
                                }
                            });
                            $scope.photos = $scope.photos.concat(images);
                            var total = $scope.photos.length + 1;
                            $scope.pageSize = total % 3 == 0 ? Math.floor(total / 3) : Math.floor(total / 3) + 1;
                            $scope.lastPageItemTotal = total % 3 == 0 ? 3 : total % 3;
                        }, function(error) {
                            console.log(error);
                            // $dialog.alert(error);
                        });
                };

                $scope.deleteImage = function() {
                    var photos = _.filter($scope.photos, function(photo) {
                        return !photo.checked;
                    });

                    if (photos.length == $scope.photos.length) {
                        $dialog.alert("请先点选要删除的照片");
                    }

                    $scope.photos = photos;

                    var total = $scope.photos.length + 1;
                    $scope.pageSize = total % 3 == 0 ? Math.floor(total / 3 ) : Math.floor(total / 3) + 1;
                    $scope.lastPageItemTotal = total % 3 == 0 ? 3 : total % 3;
                };

                $scope.clickImage = function(photoIndex) {
                    $scope.photos[photoIndex].checked = !$scope.photos[photoIndex].checked;
                };

                $scope.next = function() {
                    // todo: disabled for testing
                    if($scope.photos.length == 0 && !$window.debugger) {
                        $dialog.alert("请先拍摄指定地址门牌照片");
                        return false;
                    }


                    $window.answers[$scope.seq] = $scope.photos;
                    if (_.indexOf($window.answers.photos, parseInt($scope.seq)) == -1){
                        $window.answers.photos = $window.answers.photos ? $window.answers.photos:[];
                        $window.answers.photos.push(parseInt($scope.seq));
                    }

                    var currentSeq = $window.currentSeq;
                    var routerSize = $window.router.length;
                    if (currentSeq < (routerSize - 1)){
                        $window.currentSeq++;
                        var nextState = $window.router[$window.currentSeq];
                        $state.go(nextState, { fromSeq: 400 });
                    }
                };

                $scope.prev = function() {
                    // 删除答案
                    var currentSeq = $window.currentSeq;
                    if (currentSeq != 0){
                        $window.currentSeq--;
                        var prevState = $window.router[$window.currentSeq];
                        $state.go(prevState);
                    }
                };

        }]);

});
