define(['core/controllers'],
    function(controllers) {

    console.info('StoreRenameCtrl Load!');

    controllers.controller('StoreRenameCtrl', ['$scope', '$window', '$q', '$state', '$dialog', '$stateParams',
        function($scope, $window, $q, $state, $dialog, $stateParams) {

            $window.stateHistory.push({ state: $state.current, params: $stateParams });

            $scope.seq = $window.currentSeq;

            console.debug('seq: ' + $scope.seq, 'StoreRenameCtrl');

            $scope.answer = $window.answers[$scope.seq];

            $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                "店铺是否更名？";

            $scope.description = "如店铺已更名，请记录新的店铺名称<br>如店铺未更名，则继续下一步";

            $scope.change = function(answer) {
                $scope.answer = answer;
            };

            $scope.next = function() {
                $window.answers[$scope.seq] = $scope.answer;
                var currentSeq = $window.currentSeq;
                var routerSize = $window.router.length;
                if (currentSeq < (routerSize - 1)){
                    $window.currentSeq++;
                    var nextState = $window.router[$window.currentSeq];
                    $state.go(nextState);
                }
            };

            $scope.prev = function() {
                // delete $window.answers[$scope.seq];
                var currentSeq = $window.currentSeq;
                if (currentSeq != 0){
                    $window.currentSeq--;
                    var prevState = $window.router[$window.currentSeq];
                    $state.go(prevState);
                }
            };

    }]);

});