define(['core/controllers', 'mundo/exec'],
    function(controllers, Exec) {

    console.info('SuggestionCtrl Load!');

    controllers.controller('SuggestionCtrl', ['$scope', '$window', '$q', '$state', '$stateParams', '$dialog', '$contextUtils',
        function($scope, $window, $q, $state, $stateParams, $dialog, $contextUtils) {

            $window.stateHistory.push({ state: $state.current, params: $stateParams });

            $scope.seq = $window.currentSeq;


            $scope.suggestion = $window.answers[$scope.seq] || "";

            var fromSeq = $stateParams.fromSeq;

            $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                "您的建议和反馈（选填）";

            $scope.textChanged = function(suggestion) {
                $scope.suggestion = suggestion;
            };

            $scope.next = function() {
                $window.answers[$scope.seq] = $scope.suggestion;
                var currentSeq = $window.currentSeq;
                var routerSize = $window.router.length;
                if (currentSeq < (routerSize - 1)){
                    $window.currentSeq++;
                    var nextState = $window.router[$window.currentSeq];
                    $state.go(nextState);
                }
            };

            $scope.prev = function() {
                var currentSeq = $window.currentSeq;
                if (currentSeq != 0){
                    $window.currentSeq--;
                    var prevState = $window.router[$window.currentSeq];
                    $state.go(prevState);
                }
            };

    }]);

});