define(['core/controllers', 'mundo/exec'],
    function(controllers, Exec) {

    console.info('ThanksCtrl Load!');

    controllers.controller('ThanksCtrl', ['$scope', '$window', '$q', '$state', '$stateParams', '$dialog', '$contextUtils',
        function($scope, $window, $q, $state, $stateParams, $dialog, $contextUtils) {

            $window.stateHistory.push({ state: $state.current, params: $stateParams });

            $scope.seq = 5000;

            var fromSeq = $stateParams.fromSeq;

            $scope.title = "<i class='icon ion-information-circled' style='color: #ef473a'></i>&nbsp;" +
                "差事完成";

            $scope.description = "请确保您所提交的信息真实有效，如后期复核时发现与实际不符，会影响到差饷发放及后期的任务指派哦！";

            $scope.submit = function() {
                var answers = $window.answers;
                if (_.isEmpty(answers)) {
                    $dialog.alert("还没有数据");
                    return false;
                }
                var result = $scope.checkAnswer(answers);
                if (_.isEmpty(result)) {
                    Exec(function(args) {}, function(args) {}, "Context", "submit", [{ answer: answers }]);
                } else {
                    Exec(function(args){
                        if (args.buttonIndex < 3) {
                            if (args.buttonIndex == 1) {
                                Exec(function(args) {}, function(args) {}, "Context", "submit", [{ answer: answers }]);
                            }
                        }
                    }, function(args) {

                    }, "Dialogs", "confirm", [{ message: result + "，是否提交？", title: "提示", buttonLabels: ["提交", "取消"] }]);
                }
            };

            $scope._preProcessingAnswer = function(answers) {
                var newValue = $scope._copy(answers);
                var keys = _.keys(newValue);
                _.each(keys, function(key){
                    var value = newValue[key];
                    if (_.isArray(value)) {
                        _.each(value, function(arrayValue){
                            if (_.isObject(arrayValue)) {
                                if (!_.isUndefined(arrayValue["checked"])) {
                                    delete arrayValue["checked"]
                                }
                                if (!_.isUndefined(arrayValue["thumbnail"])) {
                                    delete arrayValue["thumbnail"]
                                }
                            }
                        });
                    }
                });

                return newValue;
            };

            $scope._copy = function(obj){
                // JSON解析之类的其实如果给定格式不对很容易出错滴，自己做好检验~
                return JSON.parse(JSON.stringify(obj));
            }

            $scope.checkAnswer = function(answers){
                var msg = '';
                if (answers.hasExecutionIssue) {
                   return msg;
                }
                //检查图片引用ID相同问题
                var photoSequences = [];
                var photoSeqMap = {}; //临时解决
                var keys = _.keys(answers);
                _.each(keys, function(key) {
                    var value = answers[key];
                    if (_.isObject(value) && !_.isUndefined(value.photoSeq)) {
                        var photoSeq = value["photoSeq"];
                        photoSequences.push(photoSeq);
                        photoSeqMap[key] = photoSeq;
                    } else if (_.isObject(value)) {
                        var array = $scope._findHistoryPhotoSeq(value);
                        var count = 1;
                        _.each(array, function(item){
                            photoSequences.push(item);
                            photoSeqMap[key + "-" + count] = item;
                            count++;
                        });
                    }
                });
                if (photoSequences.length != _.union(photoSequences).length) {
                    msg = "图片引用错误,Id:" + JSON.stringify(photoSeqMap);
                }
                return msg;
            };

            $scope._findHistoryPhotoSeq = function(value) {
                var photoSequences = [];
                var keys = _.keys(value);
                _.each(keys, function(key) {
                    var newValue = value[key];
                    if (_.isObject(newValue) && !_.isUndefined(newValue.history) && _.isArray(newValue.history)) {
                        var history = newValue["history"];
                        _.each(history, function (item) {
                            photoSequences.push(item["photoSeq"]);
                        });
                    }
                });
                return photoSequences;
            };

            $scope.prev = function() {
                var currentSeq = $window.currentSeq;
                if (currentSeq != 0){
                    $window.currentSeq--;
                    var prevState = $window.router[$window.currentSeq];
                    $state.go(prevState);
                }
            };
    }]);

});