define([], function() {
    console.info('Dialog Load!');

    function Dialog(services) {
        this.$ionicPopup = services.$ionicPopup;
        this.$q = services.$q;
    }

    Dialog.prototype.alert = function(message, title, okText) {
        this.$ionicPopup.alert({
            title: title || '提示',
            template: message,
            okText: okText || '确定',
            okType: 'button-assertive'
        });
    };

    Dialog.prototype.confirm = function(message, title, okText, cancelText) {
        var defer = this.$q.defer();
        var confirmDialog = this.$ionicPopup.confirm({
            title: title || '提示',
            template: message,
            okText: okText || '确定',
            okType: 'button-assertive',
            cancelText: cancelText || '取消',
            cancelType: 'button-default'
        });
        confirmDialog.then(function(res) {
            defer.resolve(res);
        });

        return defer.promise;
    };

    return Dialog;
});
