define(['underscore'], function(_) {
    function Page(pageNo, page, steps, $stepFactory) {
        this.pageNo = pageNo;
        this.logo = page.logo ? page.logo : "img/logo.jpg";
        this.title = page.title ? page.title : "";
        this.range = page.range;
        this.steps = [];
        var self = this;

        var strPos = _.indexOf(steps, _.find(steps, function(step, index) {
            return index + 1 === _.first(self.range);
        }));

        var endPos = _.indexOf(steps, _.find(steps, function(step, index) {
            return index + 1 === _.last(self.range);
        }));

        _.each(steps, function(step, pos) {
            if (pos >= strPos && pos <= endPos) {
                var _step = $stepFactory.create(step, pos + 1);
                console.log("-- step created --");
                console.log(_step);
                self.steps.push(_step);
            }
        });

        // console.log("-- Page Steps --");
        // console.log(self.steps);
    }

    Page.prototype.checkAnswers = function() {
        var tips = "";
        _.each(this.steps, function(step) {
            if (tips != "") return false;
            if (step.checkAnswer) {
                tips = step.checkAnswer();
            }
        });
        return tips;
    };

    return Page;
});
