define(['underscore', 'core/page'], function(_, Page) {
    console.log("PageUtils Load!");

    function PageUtils() {
    }

    PageUtils.prototype.preprocessPages = function(steps, origPages) {
        var self = this,
            pages = [], page, origPage;

        for (var seq = 1; seq <= steps.length; seq++) {
            if ((origPage = self._findSeqInOrigPages(seq, origPages))) {
                pages.push(origPage);
                if (origPage.range.length > 1) {
                    seq += origPage.range[1] - origPage.range[0];
                }
            } else {
                page = {};
                page.range = [seq];
                pages.push(page);
            }
        }

        console.log("---------- pages info - start ----------");
        _.each(pages, function(page, index) {
            console.log(index + ": " + JSON.stringify(page));
        });
        console.log("---------- pages info - end ----------");

        return pages;
    };

    PageUtils.prototype._findSeqInOrigPages = function(seq, origPages) {
        return _.find(origPages, function(page) {
            return (page.range.length === 1 && seq === page.range[0])
                || (page.range.length === 2 && seq >= page.range[0] && seq <= page.range[1])
        });
    };

    return PageUtils;
});
