define(['underscore', 'angular'], function(_, angular) {
    console.log("TaskLoader Load!");

    return function (dataSource, $http, $q, $stepFactory, $pageUtils, $contextUtils) {
        var deferred = $q.defer();
        var task = {
            dataSource: dataSource
        };

        $contextUtils.getTaskDetail($q, $http, dataSource).then(function(data) {
            task.raw = data;
            // Global Task Configuration & Attribute
            task.defaultPageTitle = data.defaultPageTitle;
            task.needCheck = data.needCheck == undefined;
            task.uuidFlag = data.uuidFlag;

            // Task Raw Steps
            task.steps = data.steps ? data.steps : data.questions;
            console.log("---------- steps info - start ----------");
            _.each(task.steps, function(step, index) {
                console.log(index + ": " + angular.toJson(step));
            });
            console.log("---------- steps info - end ----------");

            // Task Raw Pages
            task.pages = $pageUtils.preprocessPages(task.steps, data.pages);

            // Task Init Finished

            deferred.resolve(task);
        }, function(errorCode) {
            // errorCode = 10003, 加载题目失败
            deferred.reject(errorCode);
        });

        return deferred.promise;
    };
});