define([], function() {

    console.log("Validator Load!");

    function Validator(pattern, tips) {
        this.tips = tips;
        this.regexp = new RegExp(this._getPattern(pattern));
    }

    Validator.prototype._getPattern = function(macro) {
        if (macro === "{number}") {
            return "^-?\\d+$";
        } else if (macro === "{decimal}") {
            return "^-?((\\d+)|(\\d+\\.\\d+))$";
        } else if (macro === "{date}") {
            return "^(?:(?!0000)[0-9]{4}-(?:(?:0[1-9]|1[0-2])-(?:0[1-9]|1[0-9]|2[0-8])|(?:0[13-9]|1[0-2])-(?:29|30)|(?:0[13578]|1[02])-31)|(?:[0-9]{2}(?:0[48]|[2468][048]|[13579][26])|(?:0[48]|[2468][048]|[13579][26])00)-02-29)$";
        } else if (macro === "{alphabet}") {
            return "^[a-zA-Z]+$";
        } else if (macro === "{ascii}") {
            return "^[\\w\\.\\^\\$\\[\\]\\*\\+\\?\\(\\)\\<\\>\\|\\{\\}\\t\\n\\b\\,\\;\\\'\\\"\\!\\~\\`\\#\\@\\%\\=\\-\\_]+$";
        } else if (macro === "{chinese}") {
            return "^[\\u2E80-\\u9FFF]+$";
        } else if (macro === "{mobile}") {
            return "^[1][358]\\d{9}$";
        } else if (macro === "{email}") {
            return "^((\\w*)|(\\w*[-.]\\w*)*)@\\w+([-.]\\w+)*\\.\\w+([-.]\\w+)*$";
        } else if (macro === "{time}") {
            return "^(0\\d{1}|1\\d{1}|2[0-3]):([0-5]\\d{1})$";
        } else {
            return macro;
        }
    };

    Validator.prototype.validate = function(value) {
        if(this.regexp && !this.regexp.test(value)) {
            return this.tips;
        } else {
            return "";
        }
    };

    return Validator;
});
