define([], function() {
    console.log("WxConfig Load!");

    return function(jsApiSignatureUrl, appId, url, jsApiList, $http, $q, wx) {
        var deferred = $q.defer();
        $http.get(jsApiSignatureUrl, {params: {url: url, appId: appId}})
            .success(function(data) {
               wx.config({
                   debug: true,
                   appId: appId,
                   timestamp: data.timestamp,
                   nonceStr: data.noncestr,
                   signature: data.signature,
                   jsApiList: jsApiList
               });

               wx.ready(function(){
                   console.log("JS API Ticket Validation OK!");

                   wx.hideMenuItems({
                       menuList: [
                           "menuItem:share:appMessage",
                           "menuItem:share:timeline",
                           "menuItem:share:qq",
                           "menuItem:share:weiboApp",
                           "menuItem:favorite",
                           "menuItem:share:facebook",
                           "menuItem:copyUrl",
                           "menuItem:readMode",
                           "menuItem:openWithQQBrowser",
                           "menuItem:openWithSafari",
                           "menuItem:share:email"
                       ]
                   });

                   deferred.resolve(wx);
               });

               wx.error(function(error){
                   deferred.reject("Weixin JSSDK Config Error!" + error);
               });
            })
            .error(function(error) {
               deferred.reject("Weixin JSSDK Config Error!" + error);
            });
        return deferred.promise;
    }
});