define(['underscore', 'core/wx.upload'], function(_, WxUpload) {
    console.log("Native Method [Choose Image] Load!");
    function ChooseImage($q, Bridge, step) {

        var deferred = $q.defer();

        if (window.appContext == 'weixin') { // weixin
            Bridge.chooseImage({
                success: function (res) {
                    var localIds = res.localIds; // 返回选定照片的本地ID列表，localId可以作为img标签的src属性显示图片

                    /* upload weixin server */
//                    WxUpload($q, Bridge, localIds).then(function(serverIds) {
//                        var images = [];
//                        _.each(serverIds, function(serverId) {
//                            images.push({ 'imagePath': serverId });
//                        });
//                        deferred.resolve(images);
//                    }, function(error) {
//                        deferred.reject(error);
//                    });

                    var images = [];
                    _.each(localIds, function(localId) {
                        images.push({ 'imagePath': localId, 'wxFlag': true });
                    });
                    deferred.resolve(images);
                },
                fail: function(res) {
                    deferred.reject(res.errMsg);
                }
            });
        } else if (window.appContext == 'wcs') { // wcs
            var defaultParams = {
                sourceType: step.sourceType === undefined ? 2 : step.sourceType, // 照片质量：0~100，当encodingType为JPEG时有效, // 来源类型，0：拍摄、 1：从相册或文件夹选择、2：全部
                mediaType: 0, // 多媒体类型，0：照片、 1：视频、2：全部
                encodingType: step.encodingType === undefined ? 0 : step.encodingType, // 图片保存格式，0：JPEG、 1：PNG
                quality: step.quality === undefined ? 80 : step.quality, // 照片质量：0~100，当encodingType为JPEG时有效
                targetSize: step.targetSize === undefined ? { width: 360, height: 720 } : step.targetSize,// 目标尺寸，为空则不处理
                thumbnailSize: {
                    width: 300,
                    height: 300
                }, // 缩略图尺寸，为空则不返回
                maxCount: -1, // 最多选择的数量，-1为不限制，默认为1
                onOrder: step.onOrder === undefined ? false : step.onOrder, // 是否按序选择，默认为否
                saveToPhotoAlbum: step.saveToPhotoAlbum === undefined ? false : step.saveToPhotoAlbum, // 是否保存到相册，默认为否
                correctOrientation: true, // 是否纠正图片方向，默认为否
                allowEdit: false, // 是否允许编辑，默认为否
                writeMetadata: this.metadataFlag ? true : false, // 是否写入GPS定位坐标和时间，默认为否，当encodingType为JPEG时有效
                savePath: window.assignmentId ? window.assignmentId.toString() : ""
            };

            Bridge(function(args) {
                console.log("[WCS] Camera.takePicture success!");
                var images = args.medias;
                deferred.resolve(images);
            },
            function(args) {
                deferred.reject(args);
            }, "Camera", "takePicture", [defaultParams]);
        }

        return deferred.promise;
    }

    return ChooseImage;
});
