define(['underscore', 'util/toys'], function(_, Toys) {
    console.log("Native Method [Get Location] Load!");

    function GetLocation($q, Bridge) {
        var utils = new Toys();
        var deferred = $q.defer();

        if (window.appContext == 'weixin') { // weixin
            Bridge.getLocation({
                success: function (res) {
//                    var latitude = res.latitude; // 纬度，浮点数，范围为90 ~ -90
//                    var longitude = res.longitude; // 经度，浮点数，范围为180 ~ -180。
//                    var speed = res.speed; // 速度，以米/每秒计
//                    var accuracy = res.accuracy; // 位置精度

                    var result = {
                        latitude: res.latitude,
                        longitude: res.longitude
                    };
                    deferred.resolve(result);
                },
                fail: function(res) {
                    deferred.reject(res.errMsg);
                }
            });
        } else if (window.appContext == 'wcs') { // wcs
            Bridge(function(args) {
                var result = {
                    latitude: args.coords.latitude,
                    longitude: args.coords.longitude,
                    timestamp: utils.formatTime(args.timestamp, 'yyyy-MM-dd hh:mm:ss'),
                    address: args.address
                };
                deferred.resolve(result);
            },
            function(args) {
                var errorMsg = "";
                switch (args.code.toString()) {
                    case "1":
                        // errorMsg = "不允许定位"; // PERMISSION DENIED
                        errorMsg = "不允许定位，请打开手机的GPS开关";
                        break;
                    case "2":
                        errorMsg = "当前位置不可用"; // POSITION UNAVAILABLE
                        break;
                    case "3":
                        errorMsg = "已超时"; // TIMEOUT
                        break;
                    default:
                        errorMsg = "未知错误";
                }
                deferred.reject(errorMsg);
            }, "Location", "getCurrentPosition", [{ coordType: 1, reverseGeocoding: true, enableHighAccuracy: true, timeout: 20000, type: 1 }]);
        }

        return deferred.promise;
    }

    return GetLocation;
});