define([], function() {
    console.log("Native Method [Scan Code] Load!");
    function ScanCode($q, Bridge, step) {

        var deferred = $q.defer();

        if (window.appContext == 'weixin') { // weixin
            var scanType = ['qrCode', 'barCode'];
            if (step.scanType == 0) {
                scanType = ['barCode'];
            } else if (step.scanType == 1) {
                scanType = ['qrCode'];
            }
            Bridge.scanQRCode({
                needResult: 1, // 默认为0，扫描结果由微信处理，1则直接返回扫描结果，
                scanType: scanType, // 可以指定扫二维码还是一维码，默认二者都有
                success: function (res) {
                    var result = res.resultStr; // 当needResult 为 1 时，扫码返回的结果
                    deferred.resolve({ code: result, type: step.scanType });
                },
                fail: function(res) {
                    deferred.reject(res.errMsg);
                }
            });
        } else if (window.appContext == 'wcs') { // wcs
            Bridge(function(args) {
                console.log("[WCS] Code.scanCode success!");
                deferred.resolve(args);
            },
            function(args) {
                deferred.reject(args);
            }, "Code", "scanCode", [{ type: step.scanType, loadFromAlbum: step.loadFromAlbum }]);
        }
        return deferred.promise;
    }

    return ScanCode;
});