define(['underscore', 'core/step'], function(_, Step) {
    console.log("Photo Load!");

    function Photo(step, seq) {
        Step.call(this, step, seq);
        if (!this.min) this.min = 1;
        if (!this.max) this.max = 1;
        this.answer = (window.warden && window.warden.answers[seq]) != undefined ? window.warden.answers[seq] : [];
    }

    Photo.prototype = new Step();
    Photo.prototype.constructor = Photo;

    Photo.prototype.checkAnswer = function() {
        if (this.allowEmpty && this.answer.length == 0) {
            return "";
        } else {
            if (!this.allowEmpty) {
                if (this.answer.length == 0) {
                    return "请先拍照";
                }
                if (this.answer.length < this.min) {
                    return "照片数量不得少于" + this.min + "张";
                }
                if (this.answer.length > this.max) {
                    return "照片数量不得多于" + this.max + "张";
                }
            }
        }
        return "";
    };

    return Photo;
});