define(['underscore'], function(_) {
    console.log("SkuAudit Load!");

    function SkuAudit(step, seq) {
        this.type = "SkuAudit";
        this.seq = seq;
        this.skuBase = _.clone(step.skuBase);
        this.confirmSkuStep = _.clone(step.confirmSkuStep);
        this.photoSkuStep = _.clone(step.photoSkuStep);
        this.scanSkuStep = _.clone(step.scanSkuStep);
        console.log(this);

        /* todo: other steps */

        if (this.skuBase.img.length == 1) { // 商品信息单图
            this.img = this.skuBase.img[0];
        } else if (this.skuBase.img.length > 1) { // 商品信息多图
            this.slides = [];
            var self = this;
            _.each(this.skuBase.img, function(image, index) {
                self.slides.push({
                    image: image,
                    active: (index < 1)
                });
            });
        }
        console.log(this.skuBase);

        this.confirmSkuStep.fields = _.map(this.confirmSkuStep.fields, function(f, i) {
            return {
                index: i + 1,
                text: f
            };
        });

        if (this.photoSkuStep && this.photoSkuStep.min == undefined) {
            this.photoSkuStep.min = 1;
        }
        if (this.photoSkuStep && this.photoSkuStep.max == undefined) {
            this.photoSkuStep.max = 1;
        }
        if (this.scanSkuStep && this.scanSkuStep.scanType == undefined) {
            this.scanSkuStep.scanType = 2;
        }

        this.answer = (window.warden && window.warden.answers[seq]) != undefined ? window.warden.answers[seq] : {
            skuFlag: undefined,
            photo: [],
            code: undefined
        };

    }

    SkuAudit.prototype.checkAnswer = function() {
        if (this.allowEmpty && this.answer.skuFlag == undefined) {
            return "";
        } else {
            if (!this.allowEmpty && this.answer.skuFlag == undefined) {
                return "请确认该商品是否存在";
            } else {
                if (this.answer.skuFlag == 1) { // 商品存在的情况下，检查拍照与扫码结果
                    // 检查拍照
                    if (this.photoSkuStep && this.answer.photo.length < this.photoSkuStep.min) {
                        return "照片数量不得少于" + this.photoSkuStep.min + "张";
                    }
                    if (this.photoSkuStep && this.answer.photo.length > this.photoSkuStep.max) {
                        return "照片数量不得多于" + this.photoSkuStep.max + "张";
                    }

                    // 检查扫码
                    if (this.scanSkuStep && this.answer.code == undefined) {
                        return "请先扫码";
                    }
                }
            }
        }
        return "";
    };

    return SkuAudit;
});